]> git.ipfire.org Git - thirdparty/u-boot.git/blob - Makefile
rockchip: generate u-boot-rockchip.bin with binman for ARM64 boards
[thirdparty/u-boot.git] / Makefile
1 # SPDX-License-Identifier: GPL-2.0+
2
3 VERSION = 2022
4 PATCHLEVEL = 10
5 SUBLEVEL =
6 EXTRAVERSION = -rc3
7 NAME =
8
9 # *DOCUMENTATION*
10 # To see a list of typical targets execute "make help"
11 # More info can be located in ./README
12 # Comments in this file are targeted only to the developer, do not
13 # expect to learn how to build the kernel reading this file.
14
15 # Do not use make's built-in rules and variables
16 # (this increases performance and avoids hard-to-debug behaviour)
17 MAKEFLAGS += -rR
18
19 # Determine target architecture for the sandbox
20 include include/host_arch.h
21 ifeq ("", "$(CROSS_COMPILE)")
22 MK_ARCH="${shell uname -m}"
23 else
24 MK_ARCH="${shell echo $(CROSS_COMPILE) | sed -n 's/^[[:space:]]*\([^\/]*\/\)*\([^-]*\)-[^[:space:]]*/\2/p'}"
25 endif
26 unexport HOST_ARCH
27 ifeq ("x86_64", $(MK_ARCH))
28 export HOST_ARCH=$(HOST_ARCH_X86_64)
29 else ifneq (,$(findstring $(MK_ARCH), "i386" "i486" "i586" "i686"))
30 export HOST_ARCH=$(HOST_ARCH_X86)
31 else ifneq (,$(findstring $(MK_ARCH), "aarch64" "armv8l"))
32 export HOST_ARCH=$(HOST_ARCH_AARCH64)
33 else ifneq (,$(findstring $(MK_ARCH), "arm" "armv7" "armv7a" "armv7l"))
34 export HOST_ARCH=$(HOST_ARCH_ARM)
35 else ifeq ("riscv32", $(MK_ARCH))
36 export HOST_ARCH=$(HOST_ARCH_RISCV32)
37 else ifeq ("riscv64", $(MK_ARCH))
38 export HOST_ARCH=$(HOST_ARCH_RISCV64)
39 endif
40 undefine MK_ARCH
41
42 # Avoid funny character set dependencies
43 unexport LC_ALL
44 LC_COLLATE=C
45 LC_NUMERIC=C
46 export LC_COLLATE LC_NUMERIC
47
48 # Avoid interference with shell env settings
49 unexport GREP_OPTIONS
50
51 # We are using a recursive build, so we need to do a little thinking
52 # to get the ordering right.
53 #
54 # Most importantly: sub-Makefiles should only ever modify files in
55 # their own directory. If in some directory we have a dependency on
56 # a file in another dir (which doesn't happen often, but it's often
57 # unavoidable when linking the built-in.o targets which finally
58 # turn into vmlinux), we will call a sub make in that other dir, and
59 # after that we are sure that everything which is in that other dir
60 # is now up to date.
61 #
62 # The only cases where we need to modify files which have global
63 # effects are thus separated out and done before the recursive
64 # descending is started. They are now explicitly listed as the
65 # prepare rule.
66
67 # Beautify output
68 # ---------------------------------------------------------------------------
69 #
70 # Normally, we echo the whole command before executing it. By making
71 # that echo $($(quiet)$(cmd)), we now have the possibility to set
72 # $(quiet) to choose other forms of output instead, e.g.
73 #
74 # quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
75 # cmd_cc_o_c = $(CC) $(c_flags) -c -o $@ $<
76 #
77 # If $(quiet) is empty, the whole command will be printed.
78 # If it is set to "quiet_", only the short version will be printed.
79 # If it is set to "silent_", nothing will be printed at all, since
80 # the variable $(silent_cmd_cc_o_c) doesn't exist.
81 #
82 # A simple variant is to prefix commands with $(Q) - that's useful
83 # for commands that shall be hidden in non-verbose mode.
84 #
85 # $(Q)ln $@ :<
86 #
87 # If KBUILD_VERBOSE equals 0 then the above command will be hidden.
88 # If KBUILD_VERBOSE equals 1 then the above command is displayed.
89 #
90 # To put more focus on warnings, be less verbose as default
91 # Use 'make V=1' to see the full commands
92
93 ifeq ("$(origin V)", "command line")
94 KBUILD_VERBOSE = $(V)
95 endif
96 ifndef KBUILD_VERBOSE
97 KBUILD_VERBOSE = 0
98 endif
99
100 ifeq ($(KBUILD_VERBOSE),1)
101 quiet =
102 Q =
103 else
104 quiet=quiet_
105 Q = @
106 endif
107
108 # If the user is running make -s (silent mode), suppress echoing of
109 # commands
110
111 ifneq ($(filter 4.%,$(MAKE_VERSION)),) # make-4
112 ifneq ($(filter %s ,$(firstword x$(MAKEFLAGS))),)
113 quiet=silent_
114 endif
115 else # make-3.8x
116 ifneq ($(filter s% -s%,$(MAKEFLAGS)),)
117 quiet=silent_
118 endif
119 endif
120
121 export quiet Q KBUILD_VERBOSE
122
123 # kbuild supports saving output files in a separate directory.
124 # To locate output files in a separate directory two syntaxes are supported.
125 # In both cases the working directory must be the root of the kernel src.
126 # 1) O=
127 # Use "make O=dir/to/store/output/files/"
128 #
129 # 2) Set KBUILD_OUTPUT
130 # Set the environment variable KBUILD_OUTPUT to point to the directory
131 # where the output files shall be placed.
132 # export KBUILD_OUTPUT=dir/to/store/output/files/
133 # make
134 #
135 # The O= assignment takes precedence over the KBUILD_OUTPUT environment
136 # variable.
137
138 # KBUILD_SRC is set on invocation of make in OBJ directory
139 # KBUILD_SRC is not intended to be used by the regular user (for now)
140 ifeq ($(KBUILD_SRC),)
141
142 # OK, Make called in directory where kernel src resides
143 # Do we want to locate output files in a separate directory?
144 ifeq ("$(origin O)", "command line")
145 KBUILD_OUTPUT := $(O)
146 endif
147
148 # That's our default target when none is given on the command line
149 PHONY := _all
150 _all:
151
152 # Cancel implicit rules on top Makefile
153 $(CURDIR)/Makefile Makefile: ;
154
155 ifneq ($(KBUILD_OUTPUT),)
156 # Invoke a second make in the output directory, passing relevant variables
157 # check that the output directory actually exists
158 saved-output := $(KBUILD_OUTPUT)
159 KBUILD_OUTPUT := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) \
160 && /bin/pwd)
161 $(if $(KBUILD_OUTPUT),, \
162 $(error failed to create output directory "$(saved-output)"))
163
164 # Look for make include files relative to root of kernel src
165 #
166 # This does not become effective immediately because MAKEFLAGS is re-parsed
167 # once after the Makefile is read. It is OK since we are going to invoke
168 # 'sub-make' below.
169 MAKEFLAGS += --include-dir=$(CURDIR)
170
171 PHONY += $(MAKECMDGOALS) sub-make
172
173 $(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
174 @:
175
176 sub-make: FORCE
177 $(Q)$(MAKE) -C $(KBUILD_OUTPUT) KBUILD_SRC=$(CURDIR) \
178 -f $(CURDIR)/Makefile $(filter-out _all sub-make,$(MAKECMDGOALS))
179
180 # Leave processing to above invocation of make
181 skip-makefile := 1
182 endif # ifneq ($(KBUILD_OUTPUT),)
183 endif # ifeq ($(KBUILD_SRC),)
184
185 # We process the rest of the Makefile if this is the final invocation of make
186 ifeq ($(skip-makefile),)
187
188 # Do not print "Entering directory ...",
189 # but we want to display it when entering to the output directory
190 # so that IDEs/editors are able to understand relative filenames.
191 MAKEFLAGS += --no-print-directory
192
193 # Call a source code checker (by default, "sparse") as part of the
194 # C compilation.
195 #
196 # Use 'make C=1' to enable checking of only re-compiled files.
197 # Use 'make C=2' to enable checking of *all* source files, regardless
198 # of whether they are re-compiled or not.
199 #
200 # See the file "doc/sparse.txt" for more details, including
201 # where to get the "sparse" utility.
202
203 ifeq ("$(origin C)", "command line")
204 KBUILD_CHECKSRC = $(C)
205 endif
206 ifndef KBUILD_CHECKSRC
207 KBUILD_CHECKSRC = 0
208 endif
209
210 # Use make M=dir to specify directory of external module to build
211 # Old syntax make ... SUBDIRS=$PWD is still supported
212 # Setting the environment variable KBUILD_EXTMOD take precedence
213 ifdef SUBDIRS
214 KBUILD_EXTMOD ?= $(SUBDIRS)
215 endif
216
217 ifeq ("$(origin M)", "command line")
218 KBUILD_EXTMOD := $(M)
219 endif
220
221 # If building an external module we do not care about the all: rule
222 # but instead _all depend on modules
223 PHONY += all
224 ifeq ($(KBUILD_EXTMOD),)
225 _all: all
226 else
227 _all: modules
228 endif
229
230 ifeq ($(KBUILD_SRC),)
231 # building in the source tree
232 srctree := .
233 else
234 ifeq ($(KBUILD_SRC)/,$(dir $(CURDIR)))
235 # building in a subdirectory of the source tree
236 srctree := ..
237 else
238 srctree := $(KBUILD_SRC)
239 endif
240 endif
241 objtree := .
242 src := $(srctree)
243 obj := $(objtree)
244
245 VPATH := $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))
246
247 export srctree objtree VPATH
248
249 # Make sure CDPATH settings don't interfere
250 unexport CDPATH
251
252 #########################################################################
253
254 HOSTARCH := $(shell uname -m | \
255 sed -e s/i.86/x86/ \
256 -e s/sun4u/sparc64/ \
257 -e s/arm.*/arm/ \
258 -e s/sa110/arm/ \
259 -e s/ppc64/powerpc/ \
260 -e s/ppc/powerpc/ \
261 -e s/macppc/powerpc/\
262 -e s/sh.*/sh/)
263
264 HOSTOS := $(shell uname -s | tr '[:upper:]' '[:lower:]' | \
265 sed -e 's/\(cygwin\).*/cygwin/')
266
267 export HOSTARCH HOSTOS
268
269 #########################################################################
270
271 # set default to nothing for native builds
272 ifeq ($(HOSTARCH),$(ARCH))
273 CROSS_COMPILE ?=
274 endif
275
276 KCONFIG_CONFIG ?= .config
277 export KCONFIG_CONFIG
278
279 # SHELL used by kbuild
280 CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
281 else if [ -x /bin/bash ]; then echo /bin/bash; \
282 else echo sh; fi ; fi)
283
284 HOST_LFS_CFLAGS := $(shell getconf LFS_CFLAGS 2>/dev/null)
285 HOST_LFS_LDFLAGS := $(shell getconf LFS_LDFLAGS 2>/dev/null)
286 HOST_LFS_LIBS := $(shell getconf LFS_LIBS 2>/dev/null)
287
288 HOSTCC = cc
289 HOSTCXX = c++
290 KBUILD_HOSTCFLAGS := -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer \
291 $(HOST_LFS_CFLAGS) $(HOSTCFLAGS)
292 KBUILD_HOSTCXXFLAGS := -O2 $(HOST_LFS_CFLAGS) $(HOSTCXXFLAGS)
293 KBUILD_HOSTLDFLAGS := $(HOST_LFS_LDFLAGS) $(HOSTLDFLAGS)
294 KBUILD_HOSTLDLIBS := $(HOST_LFS_LIBS) $(HOSTLDLIBS)
295
296 # With the move to GCC 6, we have implicitly upgraded our language
297 # standard to GNU11 (see https://gcc.gnu.org/gcc-5/porting_to.html).
298 # Some Linux distributions (including RHEL7, SLES13, Debian 8) still
299 # have older compilers as their default, so we make it explicit for
300 # these that our host tools are GNU11 (i.e. C11 w/ GNU extensions).
301 CSTD_FLAG := -std=gnu11
302 KBUILD_HOSTCFLAGS += $(CSTD_FLAG)
303
304 ifeq ($(HOSTOS),cygwin)
305 KBUILD_HOSTCFLAGS += -ansi
306 endif
307
308 # Mac OS X / Darwin's C preprocessor is Apple specific. It
309 # generates numerous errors and warnings. We want to bypass it
310 # and use GNU C's cpp. To do this we pass the -traditional-cpp
311 # option to the compiler. Note that the -traditional-cpp flag
312 # DOES NOT have the same semantics as GNU C's flag, all it does
313 # is invoke the GNU preprocessor in stock ANSI/ISO C fashion.
314 #
315 # Apple's linker is similar, thanks to the new 2 stage linking
316 # multiple symbol definitions are treated as errors, hence the
317 # -multiply_defined suppress option to turn off this error.
318 #
319 ifeq ($(HOSTOS),darwin)
320 # get major and minor product version (e.g. '10' and '6' for Snow Leopard)
321 DARWIN_MAJOR_VERSION = $(shell sw_vers -productVersion | cut -f 1 -d '.')
322 DARWIN_MINOR_VERSION = $(shell sw_vers -productVersion | cut -f 2 -d '.')
323
324 os_x_before = $(shell if [ $(DARWIN_MAJOR_VERSION) -le $(1) -a \
325 $(DARWIN_MINOR_VERSION) -le $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
326
327 os_x_after = $(shell if [ $(DARWIN_MAJOR_VERSION) -ge $(1) -a \
328 $(DARWIN_MINOR_VERSION) -ge $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
329
330 # Snow Leopards build environment has no longer restrictions as described above
331 HOSTCC = $(call os_x_before, 10, 5, "cc", "gcc")
332 KBUILD_HOSTCFLAGS += $(call os_x_before, 10, 4, "-traditional-cpp")
333 KBUILD_HOSTLDFLAGS += $(call os_x_before, 10, 5, "-multiply_defined suppress")
334
335 # macOS Mojave (10.14.X)
336 # Undefined symbols for architecture x86_64: "_PyArg_ParseTuple"
337 KBUILD_HOSTLDFLAGS += $(call os_x_after, 10, 14, "-lpython -dynamclib", "")
338 endif
339
340 # Decide whether to build built-in, modular, or both.
341 # Normally, just do built-in.
342
343 KBUILD_MODULES :=
344 KBUILD_BUILTIN := 1
345
346 # If we have only "make modules", don't compile built-in objects.
347 # When we're building modules with modversions, we need to consider
348 # the built-in objects during the descend as well, in order to
349 # make sure the checksums are up to date before we record them.
350
351 ifeq ($(MAKECMDGOALS),modules)
352 KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
353 endif
354
355 # If we have "make <whatever> modules", compile modules
356 # in addition to whatever we do anyway.
357 # Just "make" or "make all" shall build modules as well
358
359 # U-Boot does not need modules
360 #ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
361 # KBUILD_MODULES := 1
362 #endif
363
364 #ifeq ($(MAKECMDGOALS),)
365 # KBUILD_MODULES := 1
366 #endif
367
368 # Check ths size of a binary:
369 # Args:
370 # $1: File to check
371 # #2: Size limit in bytes (decimal or 0xhex)
372 define size_check
373 actual=$$( wc -c $1 | awk '{print $$1}'); \
374 limit=$$( printf "%d" $2 ); \
375 if test $$actual -gt $$limit; then \
376 echo "$1 exceeds file size limit:" >&2; \
377 echo " limit: $$(printf %#x $$limit) bytes" >&2; \
378 echo " actual: $$(printf %#x $$actual) bytes" >&2; \
379 echo " excess: $$(printf %#x $$((actual - limit))) bytes" >&2;\
380 exit 1; \
381 fi
382 endef
383 export size_check
384
385 export KBUILD_MODULES KBUILD_BUILTIN
386 export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD
387
388 # We need some generic definitions (do not try to remake the file).
389 scripts/Kbuild.include: ;
390 include scripts/Kbuild.include
391
392 # Make variables (CC, etc...)
393
394 AS = $(CROSS_COMPILE)as
395 # Always use GNU ld
396 ifneq ($(shell $(CROSS_COMPILE)ld.bfd -v 2> /dev/null),)
397 LD = $(CROSS_COMPILE)ld.bfd
398 else
399 LD = $(CROSS_COMPILE)ld
400 endif
401 CC = $(CROSS_COMPILE)gcc
402 CPP = $(CC) -E
403 AR = $(CROSS_COMPILE)ar
404 NM = $(CROSS_COMPILE)nm
405 LDR = $(CROSS_COMPILE)ldr
406 STRIP = $(CROSS_COMPILE)strip
407 OBJCOPY = $(CROSS_COMPILE)objcopy
408 OBJDUMP = $(CROSS_COMPILE)objdump
409 LEX = flex
410 YACC = bison
411 AWK = awk
412 PERL = perl
413 PYTHON ?= python
414 PYTHON2 = python2
415 PYTHON3 ?= python3
416
417 # The devicetree compiler and pylibfdt are automatically built unless DTC is
418 # provided. If DTC is provided, it is assumed the pylibfdt is available too.
419 DTC_INTREE := $(objtree)/scripts/dtc/dtc
420 DTC ?= $(DTC_INTREE)
421 DTC_MIN_VERSION := 010406
422
423 CHECK = sparse
424
425 CHECKFLAGS := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
426 -Wbitwise -Wno-return-void -D__CHECK_ENDIAN__ $(CF)
427
428 KBUILD_CPPFLAGS := -D__KERNEL__ -D__UBOOT__
429
430 KBUILD_CFLAGS := -Wall -Wstrict-prototypes \
431 -Wno-format-security \
432 -fno-builtin -ffreestanding $(CSTD_FLAG)
433 KBUILD_CFLAGS += -fshort-wchar -fno-strict-aliasing
434 KBUILD_AFLAGS := -D__ASSEMBLY__
435 KBUILD_LDFLAGS :=
436
437 ifeq ($(cc-name),clang)
438 ifneq ($(CROSS_COMPILE),)
439 CLANG_TARGET := --target=$(notdir $(CROSS_COMPILE:%-=%))
440 GCC_TOOLCHAIN_DIR := $(dir $(shell which $(LD)))
441 CLANG_PREFIX := --prefix=$(GCC_TOOLCHAIN_DIR)
442 GCC_TOOLCHAIN := $(realpath $(GCC_TOOLCHAIN_DIR)/..)
443 endif
444 ifneq ($(GCC_TOOLCHAIN),)
445 CLANG_GCC_TC := --gcc-toolchain=$(GCC_TOOLCHAIN)
446 endif
447 KBUILD_CFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
448 KBUILD_AFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
449 KBUILD_CFLAGS += $(call cc-option, -no-integrated-as)
450 KBUILD_AFLAGS += $(call cc-option, -no-integrated-as)
451 endif
452
453 # Don't generate position independent code
454 KBUILD_CFLAGS += $(call cc-option,-fno-PIE)
455 KBUILD_AFLAGS += $(call cc-option,-fno-PIE)
456
457 # Read UBOOTRELEASE from include/config/uboot.release (if it exists)
458 UBOOTRELEASE = $(shell cat include/config/uboot.release 2> /dev/null)
459 UBOOTVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)
460
461 export VERSION PATCHLEVEL SUBLEVEL UBOOTRELEASE UBOOTVERSION
462 export ARCH CPU BOARD VENDOR SOC CPUDIR BOARDDIR
463 export CONFIG_SHELL HOSTCC KBUILD_HOSTCFLAGS CROSS_COMPILE AS LD CC
464 export CPP AR NM LDR STRIP OBJCOPY OBJDUMP KBUILD_HOSTLDFLAGS KBUILD_HOSTLDLIBS
465 export MAKE LEX YACC AWK PERL PYTHON PYTHON2 PYTHON3
466 export HOSTCXX KBUILD_HOSTCXXFLAGS CHECK CHECKFLAGS DTC DTC_FLAGS
467
468 export KBUILD_CPPFLAGS NOSTDINC_FLAGS UBOOTINCLUDE OBJCOPYFLAGS KBUILD_LDFLAGS
469 export KBUILD_CFLAGS KBUILD_AFLAGS
470
471 export CC_VERSION_TEXT := $(shell $(CC) --version | head -n 1)
472
473 # When compiling out-of-tree modules, put MODVERDIR in the module
474 # tree rather than in the kernel tree. The kernel tree might
475 # even be read-only.
476 export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions
477
478 # Files to ignore in find ... statements
479
480 export RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o \
481 -name CVS -o -name .pc -o -name .hg -o -name .git \) \
482 -prune -o
483 export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn \
484 --exclude CVS --exclude .pc --exclude .hg --exclude .git
485
486 # ===========================================================================
487 # Rules shared between *config targets and build targets
488
489 # Basic helpers built in scripts/
490 PHONY += scripts_basic
491 scripts_basic:
492 $(Q)$(MAKE) $(build)=scripts/basic
493 $(Q)rm -f .tmp_quiet_recordmcount
494
495 # To avoid any implicit rule to kick in, define an empty command.
496 scripts/basic/%: scripts_basic ;
497
498 PHONY += outputmakefile
499 # outputmakefile generates a Makefile in the output directory, if using a
500 # separate output directory. This allows convenient use of make in the
501 # output directory.
502 outputmakefile:
503 ifneq ($(KBUILD_SRC),)
504 $(Q)ln -fsn $(srctree) source
505 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/mkmakefile $(srctree)
506 endif
507
508 # To make sure we do not include .config for any of the *config targets
509 # catch them early, and hand them over to scripts/kconfig/Makefile
510 # It is allowed to specify more targets when calling make, including
511 # mixing *config targets and build targets.
512 # For example 'make oldconfig all'.
513 # Detect when mixed targets is specified, and make a second invocation
514 # of make so .config is not included in this case either (for *config).
515
516 version_h := include/generated/version_autogenerated.h
517 timestamp_h := include/generated/timestamp_autogenerated.h
518 defaultenv_h := include/generated/defaultenv_autogenerated.h
519 dt_h := include/generated/dt.h
520 env_h := include/generated/environment.h
521
522 no-dot-config-targets := clean clobber mrproper distclean \
523 help %docs check% coccicheck \
524 ubootversion backup tests check qcheck tcheck pylint \
525 pylint_err
526
527 config-targets := 0
528 mixed-targets := 0
529 dot-config := 1
530
531 ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
532 ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
533 dot-config := 0
534 endif
535 endif
536
537 ifeq ($(KBUILD_EXTMOD),)
538 ifneq ($(filter config %config,$(MAKECMDGOALS)),)
539 config-targets := 1
540 ifneq ($(words $(MAKECMDGOALS)),1)
541 mixed-targets := 1
542 endif
543 endif
544 endif
545
546 ifeq ($(mixed-targets),1)
547 # ===========================================================================
548 # We're called with mixed targets (*config and build targets).
549 # Handle them one by one.
550
551 PHONY += $(MAKECMDGOALS) __build_one_by_one
552
553 $(filter-out __build_one_by_one, $(MAKECMDGOALS)): __build_one_by_one
554 @:
555
556 __build_one_by_one:
557 $(Q)set -e; \
558 for i in $(MAKECMDGOALS); do \
559 $(MAKE) -f $(srctree)/Makefile $$i; \
560 done
561
562 else
563 ifeq ($(config-targets),1)
564 # ===========================================================================
565 # *config targets only - make sure prerequisites are updated, and descend
566 # in scripts/kconfig to make the *config target
567
568 KBUILD_DEFCONFIG := sandbox_defconfig
569 export KBUILD_DEFCONFIG KBUILD_KCONFIG
570
571 config: scripts_basic outputmakefile FORCE
572 $(Q)$(MAKE) $(build)=scripts/kconfig $@
573
574 %config: scripts_basic outputmakefile FORCE
575 $(Q)$(MAKE) $(build)=scripts/kconfig $@
576
577 else
578 # ===========================================================================
579 # Build targets only - this includes vmlinux, arch specific targets, clean
580 # targets and others. In general all targets except *config targets.
581
582 # Additional helpers built in scripts/
583 # Carefully list dependencies so we do not try to build scripts twice
584 # in parallel
585 PHONY += scripts
586 scripts: scripts_basic scripts_dtc include/config/auto.conf
587 $(Q)$(MAKE) $(build)=$(@)
588
589 ifeq ($(dot-config),1)
590 # Read in config
591 -include include/config/auto.conf
592
593 # Read in dependencies to all Kconfig* files, make sure to run
594 # oldconfig if changes are detected.
595 -include include/config/auto.conf.cmd
596
597 # To avoid any implicit rule to kick in, define an empty command
598 $(KCONFIG_CONFIG) include/config/auto.conf.cmd: ;
599
600 # If .config is newer than include/config/auto.conf, someone tinkered
601 # with it and forgot to run make oldconfig.
602 # if auto.conf.cmd is missing then we are probably in a cleaned tree so
603 # we execute the config step to be sure to catch updated Kconfig files
604 include/config/%.conf: $(KCONFIG_CONFIG) include/config/auto.conf.cmd
605 $(Q)$(MAKE) -f $(srctree)/Makefile syncconfig
606 @# If the following part fails, include/config/auto.conf should be
607 @# deleted so "make silentoldconfig" will be re-run on the next build.
608 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf || \
609 { rm -f include/config/auto.conf; false; }
610 @# include/config.h has been updated after "make silentoldconfig".
611 @# We need to touch include/config/auto.conf so it gets newer
612 @# than include/config.h.
613 @# Otherwise, 'make silentoldconfig' would be invoked twice.
614 $(Q)touch include/config/auto.conf
615
616 u-boot.cfg spl/u-boot.cfg tpl/u-boot.cfg:
617 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf $(@)
618
619 -include include/autoconf.mk
620 -include include/autoconf.mk.dep
621
622 # We want to include arch/$(ARCH)/config.mk only when include/config/auto.conf
623 # is up-to-date. When we switch to a different board configuration, old CONFIG
624 # macros are still remaining in include/config/auto.conf. Without the following
625 # gimmick, wrong config.mk would be included leading nasty warnings/errors.
626 ifneq ($(wildcard $(KCONFIG_CONFIG)),)
627 ifneq ($(wildcard include/config/auto.conf),)
628 autoconf_is_old := $(shell find . -path ./$(KCONFIG_CONFIG) -newer \
629 include/config/auto.conf)
630 ifeq ($(autoconf_is_old),)
631 include config.mk
632 include arch/$(ARCH)/Makefile
633 endif
634 endif
635 endif
636
637 # These are set by the arch-specific config.mk. Make sure they are exported
638 # so they can be used when building an EFI application.
639 export EFI_LDS # Filename of EFI link script in arch/$(ARCH)/lib
640 export EFI_CRT0 # Filename of EFI CRT0 in arch/$(ARCH)/lib
641 export EFI_RELOC # Filename of EFU relocation code in arch/$(ARCH)/lib
642 export CFLAGS_EFI # Compiler flags to add when building EFI app
643 export CFLAGS_NON_EFI # Compiler flags to remove when building EFI app
644 export EFI_TARGET # binutils target if EFI is natively supported
645
646 # If board code explicitly specified LDSCRIPT or CONFIG_SYS_LDSCRIPT, use
647 # that (or fail if absent). Otherwise, search for a linker script in a
648 # standard location.
649
650 ifndef LDSCRIPT
651 #LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds.debug
652 ifdef CONFIG_SYS_LDSCRIPT
653 # need to strip off double quotes
654 LDSCRIPT := $(srctree)/$(CONFIG_SYS_LDSCRIPT:"%"=%)
655 endif
656 endif
657
658 # If there is no specified link script, we look in a number of places for it
659 ifndef LDSCRIPT
660 ifeq ($(wildcard $(LDSCRIPT)),)
661 LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds
662 endif
663 ifeq ($(wildcard $(LDSCRIPT)),)
664 LDSCRIPT := $(srctree)/$(CPUDIR)/u-boot.lds
665 endif
666 ifeq ($(wildcard $(LDSCRIPT)),)
667 LDSCRIPT := $(srctree)/arch/$(ARCH)/cpu/u-boot.lds
668 endif
669 endif
670
671 else
672 # Dummy target needed, because used as prerequisite
673 include/config/auto.conf: ;
674 endif # $(dot-config)
675
676 ifdef CONFIG_CC_OPTIMIZE_FOR_DEBUG
677 KBUILD_HOSTCFLAGS := -Wall -Wstrict-prototypes -Og -g -fomit-frame-pointer \
678 $(HOST_LFS_CFLAGS) $(HOSTCFLAGS)
679 # Avoid false positives -Wmaybe-uninitialized
680 # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=78394
681 KBUILD_HOSTCFLAGS += -Wno-maybe-uninitialized
682 KBUILD_HOSTCXXFLAGS := -Og -g $(HOST_LFS_CFLAGS) $(HOSTCXXFLAGS)
683 endif
684
685 #
686 # Xtensa linker script cannot be preprocessed with -ansi because of
687 # preprocessor operations on strings that don't make C identifiers.
688 #
689 ifeq ($(CONFIG_XTENSA),)
690 LDPPFLAGS += -ansi
691 endif
692
693 ifdef CONFIG_CC_OPTIMIZE_FOR_SIZE
694 KBUILD_CFLAGS += -Os
695 endif
696
697 ifdef CONFIG_CC_OPTIMIZE_FOR_SPEED
698 KBUILD_CFLAGS += -O2
699 endif
700
701 ifdef CONFIG_CC_OPTIMIZE_FOR_DEBUG
702 KBUILD_CFLAGS += -Og -Wno-maybe-uninitialized
703 # Avoid false positives -Wmaybe-uninitialized
704 # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=78394
705 KBUILD_CFLAGS += -Wno-maybe-uninitialized
706 endif
707
708 LTO_CFLAGS :=
709 LTO_FINAL_LDFLAGS :=
710 export LTO_CFLAGS LTO_FINAL_LDFLAGS
711 ifdef CONFIG_LTO
712 ifeq ($(cc-name),clang)
713 LTO_CFLAGS += -flto
714 LTO_FINAL_LDFLAGS += -flto
715
716 AR = $(shell $(CC) -print-prog-name=llvm-ar)
717 NM = $(shell $(CC) -print-prog-name=llvm-nm)
718 else
719 NPROC := $(shell nproc 2>/dev/null || echo 1)
720 LTO_CFLAGS += -flto=$(NPROC)
721 LTO_FINAL_LDFLAGS += -fuse-linker-plugin -flto=$(NPROC)
722
723 # use plugin aware tools
724 AR = $(CROSS_COMPILE)gcc-ar
725 NM = $(CROSS_COMPILE)gcc-nm
726 endif
727
728 CFLAGS_NON_EFI += $(LTO_CFLAGS)
729
730 KBUILD_CFLAGS += $(LTO_CFLAGS)
731 endif
732
733 ifeq ($(CONFIG_STACKPROTECTOR),y)
734 KBUILD_CFLAGS += $(call cc-option,-fstack-protector-strong)
735 CFLAGS_EFI += $(call cc-option,-fno-stack-protector)
736 else
737 KBUILD_CFLAGS += $(call cc-option,-fno-stack-protector)
738 endif
739 KBUILD_CFLAGS += $(call cc-option,-fno-delete-null-pointer-checks)
740
741 # disable pointer signed / unsigned warnings in gcc 4.0
742 KBUILD_CFLAGS += -Wno-pointer-sign
743
744 # disable stringop warnings in gcc 8+
745 KBUILD_CFLAGS += $(call cc-disable-warning, stringop-truncation)
746
747 KBUILD_CFLAGS += $(call cc-disable-warning, zero-length-bounds)
748 KBUILD_CFLAGS += $(call cc-disable-warning, array-bounds)
749 KBUILD_CFLAGS += $(call cc-disable-warning, stringop-overflow)
750
751 # Enabled with W=2, disabled by default as noisy
752 KBUILD_CFLAGS += $(call cc-disable-warning, maybe-uninitialized)
753
754 # change __FILE__ to the relative path from the srctree
755 KBUILD_CFLAGS += $(call cc-option,-fmacro-prefix-map=$(srctree)/=)
756
757 KBUILD_CFLAGS += -g
758 # $(KBUILD_AFLAGS) sets -g, which causes gcc to pass a suitable -g<format>
759 # option to the assembler.
760 KBUILD_AFLAGS += -g
761
762 # Report stack usage if supported
763 # ARC tools based on GCC 7.1 has an issue with stack usage
764 # with naked functions, see commit message for more details
765 ifndef CONFIG_ARC
766 ifeq ($(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-stack-usage.sh $(CC)),y)
767 KBUILD_CFLAGS += -fstack-usage
768 endif
769 endif
770
771 KBUILD_CFLAGS += $(call cc-option,-Wno-format-nonliteral)
772 KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
773
774 ifdef CONFIG_CC_IS_CLANG
775 KBUILD_CPPFLAGS += $(call cc-option,-Qunused-arguments,)
776 KBUILD_CFLAGS += $(call cc-disable-warning, format-invalid-specifier)
777 KBUILD_CFLAGS += $(call cc-disable-warning, gnu)
778 KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
779 # Quiet clang warning: comparison of unsigned expression < 0 is always false
780 KBUILD_CFLAGS += $(call cc-disable-warning, tautological-compare)
781 # CLANG uses a _MergedGlobals as optimization, but this breaks modpost, as the
782 # source of a reference will be _MergedGlobals and not on of the whitelisted names.
783 # See modpost pattern 2
784 KBUILD_CFLAGS += $(call cc-option, -mno-global-merge,)
785 KBUILD_CFLAGS += $(call cc-option, -fcatch-undefined-behavior)
786 endif
787
788 # These warnings generated too much noise in a regular build.
789 # Use make W=1 to enable them (see scripts/Makefile.extrawarn)
790 KBUILD_CFLAGS += $(call cc-disable-warning, unused-but-set-variable)
791
792 # Prohibit date/time macros, which would make the build non-deterministic
793 KBUILD_CFLAGS += $(call cc-option,-Werror=date-time)
794
795 include scripts/Makefile.extrawarn
796
797 # Add user supplied CPPFLAGS, AFLAGS and CFLAGS as the last assignments
798 KBUILD_CPPFLAGS += $(KCPPFLAGS)
799 KBUILD_AFLAGS += $(KAFLAGS)
800 KBUILD_CFLAGS += $(KCFLAGS)
801
802 KBUILD_HOSTCFLAGS += $(if $(CONFIG_TOOLS_DEBUG),-g)
803
804 # Use UBOOTINCLUDE when you must reference the include/ directory.
805 # Needed to be compatible with the O= option
806 UBOOTINCLUDE := \
807 -Iinclude \
808 $(if $(KBUILD_SRC), -I$(srctree)/include) \
809 $(if $(CONFIG_$(SPL_)SYS_THUMB_BUILD), \
810 $(if $(CONFIG_HAS_THUMB2), \
811 $(if $(CONFIG_CPU_V7M), \
812 -I$(srctree)/arch/arm/thumb1/include), \
813 -I$(srctree)/arch/arm/thumb1/include)) \
814 -I$(srctree)/arch/$(ARCH)/include \
815 -include $(srctree)/include/linux/kconfig.h
816
817 NOSTDINC_FLAGS += -nostdinc -isystem $(shell $(CC) -print-file-name=include)
818
819 # FIX ME
820 cpp_flags := $(KBUILD_CPPFLAGS) $(PLATFORM_CPPFLAGS) $(UBOOTINCLUDE) \
821 $(NOSTDINC_FLAGS)
822 c_flags := $(KBUILD_CFLAGS) $(cpp_flags)
823
824 #########################################################################
825 # U-Boot objects....order is important (i.e. start must be first)
826
827 HAVE_VENDOR_COMMON_LIB = $(if $(wildcard $(srctree)/board/$(VENDOR)/common/Makefile),y,n)
828
829 libs-$(CONFIG_API) += api/
830 libs-$(HAVE_VENDOR_COMMON_LIB) += board/$(VENDOR)/common/
831 libs-y += boot/
832 libs-y += cmd/
833 libs-y += common/
834 libs-$(CONFIG_OF_EMBED) += dts/
835 libs-y += env/
836 libs-y += lib/
837 libs-y += fs/
838 libs-y += net/
839 libs-y += disk/
840 libs-y += drivers/
841 libs-$(CONFIG_SYS_FSL_DDR) += drivers/ddr/fsl/
842 libs-$(CONFIG_SYS_FSL_MMDC) += drivers/ddr/fsl/
843 libs-$(CONFIG_$(SPL_)ALTERA_SDRAM) += drivers/ddr/altera/
844 libs-y += drivers/usb/cdns3/
845 libs-y += drivers/usb/dwc3/
846 libs-y += drivers/usb/common/
847 libs-y += drivers/usb/emul/
848 libs-y += drivers/usb/eth/
849 libs-$(CONFIG_USB_DEVICE) += drivers/usb/gadget/
850 libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/
851 libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/udc/
852 libs-y += drivers/usb/host/
853 libs-y += drivers/usb/mtu3/
854 libs-y += drivers/usb/musb/
855 libs-y += drivers/usb/musb-new/
856 libs-y += drivers/usb/isp1760/
857 libs-y += drivers/usb/phy/
858 libs-y += drivers/usb/ulpi/
859 ifdef CONFIG_POST
860 libs-y += post/
861 endif
862 libs-$(CONFIG_$(SPL_TPL_)UNIT_TEST) += test/
863 libs-$(CONFIG_UT_ENV) += test/env/
864 libs-$(CONFIG_UT_OPTEE) += test/optee/
865 libs-$(CONFIG_UT_OVERLAY) += test/overlay/
866
867 libs-y += $(if $(BOARDDIR),board/$(BOARDDIR)/)
868
869 libs-y := $(sort $(libs-y))
870
871 u-boot-dirs := $(patsubst %/,%,$(filter %/, $(libs-y))) tools examples
872
873 u-boot-alldirs := $(sort $(u-boot-dirs) $(patsubst %/,%,$(filter %/, $(libs-))))
874
875 libs-y := $(patsubst %/, %/built-in.o, $(libs-y))
876
877 u-boot-init := $(head-y)
878 u-boot-main := $(libs-y)
879
880
881 # Add GCC lib
882 ifeq ($(CONFIG_USE_PRIVATE_LIBGCC),y)
883 PLATFORM_LIBGCC = arch/$(ARCH)/lib/lib.a
884 else
885 PLATFORM_LIBGCC := -L $(shell dirname `$(CC) $(c_flags) -print-libgcc-file-name`) -lgcc
886 endif
887 PLATFORM_LIBS += $(PLATFORM_LIBGCC)
888
889 ifdef CONFIG_CC_COVERAGE
890 KBUILD_CFLAGS += --coverage
891 PLATFORM_LIBGCC += -lgcov
892 endif
893
894 export PLATFORM_LIBS
895 export PLATFORM_LIBGCC
896
897 # Special flags for CPP when processing the linker script.
898 # Pass the version down so we can handle backwards compatibility
899 # on the fly.
900 LDPPFLAGS += \
901 -include $(srctree)/include/u-boot/u-boot.lds.h \
902 -DCPUDIR=$(CPUDIR) \
903 $(shell $(LD) --version | \
904 sed -ne 's/GNU ld version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/-DLD_MAJOR=\1 -DLD_MINOR=\2/p')
905
906 #########################################################################
907 #########################################################################
908
909 ifneq ($(CONFIG_BOARD_SIZE_LIMIT),)
910 BOARD_SIZE_CHECK= @ $(call size_check,$@,$(CONFIG_BOARD_SIZE_LIMIT))
911 else
912 BOARD_SIZE_CHECK =
913 endif
914
915 ifneq ($(CONFIG_SPL_SIZE_LIMIT),0x0)
916 SPL_SIZE_CHECK = @$(call size_check,$@,$$(tools/spl_size_limit))
917 else
918 SPL_SIZE_CHECK =
919 endif
920
921 ifneq ($(CONFIG_TPL_SIZE_LIMIT),0x0)
922 TPL_SIZE_CHECK = @$(call size_check,$@,$(CONFIG_TPL_SIZE_LIMIT))
923 else
924 TPL_SIZE_CHECK =
925 endif
926
927 ifneq ($(CONFIG_VPL_SIZE_LIMIT),0x0)
928 VPL_SIZE_CHECK = @$(call size_check,$@,$(CONFIG_VPL_SIZE_LIMIT))
929 else
930 VPL_SIZE_CHECK =
931 endif
932
933 # Statically apply RELA-style relocations (currently arm64 only)
934 # This is useful for arm64 where static relocation needs to be performed on
935 # the raw binary, but certain simulators only accept an ELF file (but don't
936 # do the relocation).
937 ifneq ($(CONFIG_STATIC_RELA),)
938 # $(2) is u-boot ELF, $(3) is u-boot bin, $(4) is text base
939 quiet_cmd_static_rela = RELOC $@
940 cmd_static_rela = \
941 tools/relocate-rela $(3) $(2)
942 else
943 quiet_cmd_static_rela =
944 cmd_static_rela =
945 endif
946
947 # Always append INPUTS so that arch config.mk's can add custom ones
948 INPUTS-y += u-boot.srec u-boot.bin u-boot.sym System.map binary_size_check
949
950 INPUTS-$(CONFIG_ONENAND_U_BOOT) += u-boot-onenand.bin
951 ifeq ($(CONFIG_SPL_FSL_PBL),y)
952 INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot-with-spl-pbl.bin
953 else
954 ifneq ($(CONFIG_NXP_ESBC), y)
955 # For Secure Boot The Image needs to be signed and Header must also
956 # be included. So The image has to be built explicitly
957 INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot.pbl
958 endif
959 endif
960 INPUTS-$(CONFIG_SPL) += spl/u-boot-spl.bin
961 ifeq ($(CONFIG_MX6)$(CONFIG_IMX_HAB), yy)
962 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
963 else
964 ifeq ($(CONFIG_MX7)$(CONFIG_IMX_HAB), yy)
965 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
966 else
967 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot.img
968 endif
969 endif
970 INPUTS-$(CONFIG_TPL) += tpl/u-boot-tpl.bin
971 INPUTS-$(CONFIG_VPL) += vpl/u-boot-vpl.bin
972
973 # Allow omitting the .dtb output if it is not normally used
974 INPUTS-$(CONFIG_OF_SEPARATE) += $(if $(CONFIG_OF_OMIT_DTB),dts/dt.dtb,u-boot.dtb)
975 ifeq ($(CONFIG_SPL_FRAMEWORK),y)
976 INPUTS-$(CONFIG_OF_SEPARATE) += u-boot-dtb.img
977 endif
978 INPUTS-$(CONFIG_SANDBOX) += u-boot.dtb
979 ifneq ($(CONFIG_SPL_TARGET),)
980 INPUTS-$(CONFIG_SPL) += $(CONFIG_SPL_TARGET:"%"=%)
981 endif
982 INPUTS-$(CONFIG_REMAKE_ELF) += u-boot.elf
983 INPUTS-$(CONFIG_EFI_APP) += u-boot-app.efi
984 INPUTS-$(CONFIG_EFI_STUB) += u-boot-payload.efi
985
986 # Generate this input file for binman
987 ifeq ($(CONFIG_SPL),)
988 INPUTS-$(CONFIG_ARCH_MEDIATEK) += u-boot-mtk.bin
989 endif
990
991 # Add optional build target if defined in board/cpu/soc headers
992 ifneq ($(CONFIG_BUILD_TARGET),)
993 INPUTS-y += $(CONFIG_BUILD_TARGET:"%"=%)
994 endif
995
996 ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
997 INPUTS-y += init_sp_bss_offset_check
998 endif
999
1000 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1001 INPUTS-y += u-boot-with-dtb.bin
1002 endif
1003
1004 ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
1005 # On ARM64 this target is produced by binman so we don't need this dep
1006 ifeq ($(CONFIG_ARM64),y)
1007 ifeq ($(CONFIG_SPL),y)
1008 INPUTS-y += u-boot.itb
1009 endif
1010 else
1011 ifeq ($(CONFIG_SPL),y)
1012 # Generate these inputs for binman which will create the output files
1013 INPUTS-y += u-boot.img
1014 endif
1015 endif
1016 endif
1017
1018 INPUTS-$(CONFIG_X86) += u-boot-x86-start16.bin u-boot-x86-reset16.bin \
1019 $(if $(CONFIG_SPL_X86_16BIT_INIT),spl/u-boot-spl.bin) \
1020 $(if $(CONFIG_TPL_X86_16BIT_INIT),tpl/u-boot-tpl.bin)
1021
1022 LDFLAGS_u-boot += $(LDFLAGS_FINAL)
1023
1024 # Avoid 'Not enough room for program headers' error on binutils 2.28 onwards.
1025 LDFLAGS_u-boot += $(call ld-option, --no-dynamic-linker)
1026
1027 # ld.lld support
1028 LDFLAGS_u-boot += -z notext
1029
1030 LDFLAGS_u-boot += --build-id=none
1031
1032 ifeq ($(CONFIG_ARC)$(CONFIG_NIOS2)$(CONFIG_X86)$(CONFIG_XTENSA),)
1033 LDFLAGS_u-boot += -Ttext $(CONFIG_SYS_TEXT_BASE)
1034 endif
1035
1036 # insure the checker run with the right endianness
1037 CHECKFLAGS += $(if $(CONFIG_CPU_BIG_ENDIAN),-mbig-endian,-mlittle-endian)
1038
1039 # the checker needs the correct machine size
1040 CHECKFLAGS += $(if $(CONFIG_64BIT),-m64,-m32)
1041
1042 # Normally we fill empty space with 0xff
1043 quiet_cmd_objcopy = OBJCOPY $@
1044 cmd_objcopy = $(OBJCOPY) --gap-fill=0xff $(OBJCOPYFLAGS) \
1045 $(OBJCOPYFLAGS_$(@F)) $< $@
1046
1047 # Provide a version which does not do this, for use by EFI
1048 quiet_cmd_zobjcopy = OBJCOPY $@
1049 cmd_zobjcopy = $(OBJCOPY) $(OBJCOPYFLAGS) $(OBJCOPYFLAGS_$(@F)) $< $@
1050
1051 quiet_cmd_efipayload = OBJCOPY $@
1052 cmd_efipayload = $(OBJCOPY) -I binary -O $(EFIPAYLOAD_BFDTARGET) -B $(EFIPAYLOAD_BFDARCH) $< $@
1053
1054 MKIMAGEOUTPUT ?= /dev/null
1055
1056 quiet_cmd_mkimage = MKIMAGE $@
1057 cmd_mkimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) -d $< $@ \
1058 >$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1059
1060 quiet_cmd_mkfitimage = MKIMAGE $@
1061 cmd_mkfitimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) \
1062 -f $(U_BOOT_ITS) -p $(CONFIG_FIT_EXTERNAL_OFFSET) $@ \
1063 >$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1064
1065 quiet_cmd_cat = CAT $@
1066 cmd_cat = cat $(filter-out $(PHONY), $^) > $@
1067
1068 append = cat $(filter-out $< $(PHONY), $^) >> $@
1069
1070 quiet_cmd_pad_cat = CAT $@
1071 cmd_pad_cat = $(cmd_objcopy) && $(append) || { rm -f $@; false; }
1072
1073 quiet_cmd_lzma = LZMA $@
1074 cmd_lzma = lzma -c -z -k -9 $< > $@
1075
1076 cfg: u-boot.cfg
1077
1078 quiet_cmd_cfgcheck = CFGCHK $2
1079 cmd_cfgcheck = $(srctree)/scripts/check-config.sh $2 \
1080 $(srctree)/scripts/config_whitelist.txt $(srctree)
1081
1082 quiet_cmd_ofcheck = OFCHK $2
1083 cmd_ofcheck = $(srctree)/scripts/check-of.sh $2 \
1084 $(srctree)/scripts/of_allowlist.txt
1085
1086 # Concat the value of all the CONFIGs (result is 'y' or 'yy', etc. )
1087 got = $(foreach cfg,$(1),$($(cfg)))
1088
1089 # expected value 'y for each one
1090 expect = $(foreach cfg,$(1),y)
1091
1092 # Show a deprecation message
1093 # Args:
1094 # 1: List of CONFIG_DM_... to migrate to (e.g. "CONFIG_DM_MMC CONFIG_BLK")
1095 # 2: Name of component (e.g . "Ethernet drivers")
1096 # 3: Release deadline (e.g. "v202.07")
1097 # 4: Condition to require before checking (e.g. "$(CONFIG_NET)")
1098 # Note: Script avoids bash construct, hence the strange double 'if'
1099 # (patches welcome!)
1100 define deprecated
1101 @if [ -n "$(strip $(4))" ]; then if [ "$(got)" != "$(expect)" ]; then \
1102 echo >&2 "===================== WARNING ======================"; \
1103 echo >&2 "This board does not use $(firstword $(1)) (Driver Model"; \
1104 echo >&2 "for $(2)). Please update the board to use"; \
1105 echo >&2 "$(firstword $(1)) before the $(3) release. Failure to"; \
1106 echo >&2 "update by the deadline may result in board removal."; \
1107 echo >&2 "See doc/develop/driver-model/migration.rst for more info."; \
1108 echo >&2 "===================================================="; \
1109 fi; fi
1110
1111 endef
1112
1113 PHONY += inputs
1114 inputs: $(INPUTS-y)
1115
1116 all: .binman_stamp inputs
1117 ifeq ($(CONFIG_BINMAN),y)
1118 $(call if_changed,binman)
1119 endif
1120
1121 # Timestamp file to make sure that binman always runs
1122 .binman_stamp: FORCE
1123 @touch $@
1124
1125 ifeq ($(CONFIG_DEPRECATED),y)
1126 $(warning "You have deprecated configuration options enabled in your .config! Please check your configuration.")
1127 endif
1128 ifeq ($(CONFIG_OF_EMBED)$(CONFIG_EFI_APP),y)
1129 @echo >&2 "===================== WARNING ======================"
1130 @echo >&2 "CONFIG_OF_EMBED is enabled. This option should only"
1131 @echo >&2 "be used for debugging purposes. Please use"
1132 @echo >&2 "CONFIG_OF_SEPARATE for boards in mainline."
1133 @echo >&2 "See doc/develop/devicetree/control.rst for more info."
1134 @echo >&2 "===================================================="
1135 endif
1136 ifneq ($(CONFIG_SPL_FIT_GENERATOR),)
1137 @echo >&2 "===================== WARNING ======================"
1138 @echo >&2 "This board uses CONFIG_SPL_FIT_GENERATOR. Please migrate"
1139 @echo >&2 "to binman instead, to avoid the proliferation of"
1140 @echo >&2 "arch-specific scripts with no tests."
1141 @echo >&2 "===================================================="
1142 endif
1143 ifneq ($(CONFIG_DM),y)
1144 @echo >&2 "===================== WARNING ======================"
1145 @echo >&2 "This board does not use CONFIG_DM. CONFIG_DM will be"
1146 @echo >&2 "compulsory starting with the v2020.01 release."
1147 @echo >&2 "Failure to update may result in board removal."
1148 @echo >&2 "See doc/develop/driver-model/migration.rst for more info."
1149 @echo >&2 "===================================================="
1150 endif
1151 $(call deprecated,CONFIG_WDT,DM watchdog,v2019.10,\
1152 $(CONFIG_WATCHDOG)$(CONFIG_HW_WATCHDOG))
1153 $(call deprecated,CONFIG_DM_I2C,I2C drivers,v2022.04,$(CONFIG_SYS_I2C_LEGACY))
1154 $(call deprecated,CONFIG_DM_KEYBOARD,Keyboard drivers,v2022.10,$(CONFIG_KEYBOARD))
1155 @# CONFIG_SYS_TIMER_RATE has brackets in it for some boards which
1156 @# confuses this rule. Use if() to send just a single character which
1157 @# is enable to tell 'deprecated' that one of these symbols exists
1158 $(call deprecated,CONFIG_TIMER,Timer drivers,v2023.01,$(if $(strip $(CONFIG_SYS_TIMER_RATE)$(CONFIG_SYS_TIMER_COUNTER)),x))
1159 $(call deprecated,CONFIG_DM_SERIAL,Serial drivers,v2023.04,$(CONFIG_SERIAL))
1160 $(call deprecated,CONFIG_DM_SCSI,SCSI drivers,v2023.04,$(CONFIG_SCSI))
1161 @# Check that this build does not use CONFIG options that we do not
1162 @# know about unless they are in Kconfig. All the existing CONFIG
1163 @# options are whitelisted, so new ones should not be added.
1164 $(call cmd,cfgcheck,u-boot.cfg)
1165 @# Check that this build does not override OF_HAS_PRIOR_STAGE by
1166 @# disabling OF_BOARD.
1167 $(call cmd,ofcheck,$(KCONFIG_CONFIG))
1168
1169 PHONY += dtbs
1170 dtbs: dts/dt.dtb
1171 @:
1172 dts/dt.dtb: u-boot
1173 $(Q)$(MAKE) $(build)=dts dtbs
1174
1175 quiet_cmd_copy = COPY $@
1176 cmd_copy = cp $< $@
1177
1178 ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1179
1180 ifeq ($(CONFIG_MULTI_DTB_FIT_LZO),y)
1181 FINAL_DTB_CONTAINER = fit-dtb.blob.lzo
1182 else ifeq ($(CONFIG_MULTI_DTB_FIT_GZIP),y)
1183 FINAL_DTB_CONTAINER = fit-dtb.blob.gz
1184 else
1185 FINAL_DTB_CONTAINER = fit-dtb.blob
1186 endif
1187
1188 fit-dtb.blob.gz: fit-dtb.blob
1189 @gzip -kf9 $< > $@
1190
1191 fit-dtb.blob.lzo: fit-dtb.blob
1192 @lzop -f9 $< > $@
1193
1194 fit-dtb.blob: dts/dt.dtb FORCE
1195 $(call if_changed,mkimage)
1196 ifneq ($(SOURCE_DATE_EPOCH),)
1197 touch -d @$(SOURCE_DATE_EPOCH) fit-dtb.blob
1198 chmod 0600 fit-dtb.blob
1199 endif
1200
1201 MKIMAGEFLAGS_fit-dtb.blob = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1202 -a 0 -e 0 -E \
1203 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) -d /dev/null
1204
1205 MKIMAGEFLAGS_fit-dtb.blob += -B 0x8
1206
1207 ifneq ($(EXT_DTB),)
1208 u-boot-fit-dtb.bin: u-boot-nodtb.bin $(EXT_DTB)
1209 $(call if_changed,cat)
1210 else
1211 u-boot-fit-dtb.bin: u-boot-nodtb.bin $(FINAL_DTB_CONTAINER)
1212 $(call if_changed,cat)
1213 endif
1214
1215 u-boot.bin: u-boot-fit-dtb.bin FORCE
1216 $(call if_changed,copy)
1217
1218 u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1219 $(call if_changed,cat)
1220
1221 else ifeq ($(CONFIG_OF_SEPARATE).$(CONFIG_OF_OMIT_DTB),y.)
1222 u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1223 $(call if_changed,cat)
1224
1225 u-boot.bin: u-boot-dtb.bin FORCE
1226 $(call if_changed,copy)
1227 else
1228 u-boot.bin: u-boot-nodtb.bin FORCE
1229 $(call if_changed,copy)
1230 endif
1231
1232 # we call Makefile in arch/arm/mach-imx which
1233 # has targets which are dependent on targets defined
1234 # here. make could not resolve them and we must ensure
1235 # that they are finished before calling imx targets
1236 ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1237 IMX_DEPS = u-boot-fit-dtb.bin
1238 endif
1239
1240 %.imx: $(IMX_DEPS) %.bin
1241 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1242 $(BOARD_SIZE_CHECK)
1243
1244 %.vyb: %.imx
1245 $(Q)$(MAKE) $(build)=arch/arm/cpu/armv7/vf610 $@
1246
1247 quiet_cmd_copy = COPY $@
1248 cmd_copy = cp $< $@
1249
1250 u-boot.dtb: dts/dt.dtb
1251 $(call cmd,copy)
1252
1253 OBJCOPYFLAGS_u-boot.hex := -O ihex
1254
1255 OBJCOPYFLAGS_u-boot.srec := -O srec
1256
1257 u-boot.hex u-boot.srec: u-boot FORCE
1258 $(call if_changed,objcopy)
1259
1260 OBJCOPYFLAGS_u-boot-elf.srec := $(OBJCOPYFLAGS_u-boot.srec)
1261
1262 u-boot-elf.srec: u-boot.elf FORCE
1263 $(call if_changed,objcopy)
1264
1265 OBJCOPYFLAGS_u-boot-spl.srec = $(OBJCOPYFLAGS_u-boot.srec)
1266
1267 spl/u-boot-spl.srec: spl/u-boot-spl FORCE
1268 $(call if_changed,objcopy)
1269
1270 %.scif: %.srec
1271 $(Q)$(MAKE) $(build)=arch/arm/mach-rmobile $@
1272
1273 OBJCOPYFLAGS_u-boot-nodtb.bin := -O binary \
1274 $(if $(CONFIG_X86_16BIT_INIT),-R .start16 -R .resetvec) \
1275 $(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR),$(if $(CONFIG_OF_EMBED),,-R .bootpg -R .resetvec))
1276
1277 binary_size_check: u-boot-nodtb.bin FORCE
1278 @file_size=$(shell wc -c u-boot-nodtb.bin | awk '{print $$1}') ; \
1279 map_size=$(shell cat u-boot.map | \
1280 awk '/_image_copy_start/ {start = $$1} /_image_binary_end/ {end = $$1} END {if (start != "" && end != "") print "ibase=16; " toupper(end) " - " toupper(start)}' \
1281 | sed 's/0X//g' \
1282 | bc); \
1283 if [ "" != "$$map_size" ]; then \
1284 if test $$map_size -ne $$file_size; then \
1285 echo "u-boot.map shows a binary size of $$map_size" >&2 ; \
1286 echo " but u-boot-nodtb.bin shows $$file_size" >&2 ; \
1287 exit 1; \
1288 fi; \
1289 fi
1290
1291 ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
1292 ifneq ($(CONFIG_SYS_MALLOC_F_LEN),)
1293 subtract_sys_malloc_f_len = space=$$(($${space} - $(CONFIG_SYS_MALLOC_F_LEN)))
1294 else
1295 subtract_sys_malloc_f_len = true
1296 endif
1297 # The 1/4 margin below is somewhat arbitrary. The likely initial SP usage is
1298 # so low that the DTB could probably use 90%+ of the available space, for
1299 # current values of CONFIG_SYS_INIT_SP_BSS_OFFSET at least. However, let's be
1300 # safe for now and tweak this later if space becomes tight.
1301 # A rejected alternative would be to check that some absolute minimum stack
1302 # space was available. However, since CONFIG_SYS_INIT_SP_BSS_OFFSET is
1303 # deliberately build-specific, to take account of build-to-build stack usage
1304 # differences due to different feature sets, there is no common absolute value
1305 # to check against.
1306 init_sp_bss_offset_check: u-boot.dtb FORCE
1307 @dtb_size=$(shell wc -c u-boot.dtb | awk '{print $$1}') ; \
1308 space=$(CONFIG_SYS_INIT_SP_BSS_OFFSET) ; \
1309 $(subtract_sys_malloc_f_len) ; \
1310 quarter_space=$$(($${space} / 4)) ; \
1311 if [ $${dtb_size} -gt $${quarter_space} ]; then \
1312 echo "u-boot.dtb is larger than 1 quarter of " >&2 ; \
1313 echo "(CONFIG_SYS_INIT_SP_BSS_OFFSET - CONFIG_SYS_MALLOC_F_LEN)" >&2 ; \
1314 exit 1 ; \
1315 fi
1316 endif
1317
1318 shell_cmd = { $(call echo-cmd,$(1)) $(cmd_$(1)); }
1319
1320 quiet_cmd_objcopy_uboot = OBJCOPY $@
1321 ifdef cmd_static_rela
1322 cmd_objcopy_uboot = $(cmd_objcopy) && $(call shell_cmd,static_rela,$<,$@,$(CONFIG_SYS_TEXT_BASE)) || { rm -f $@; false; }
1323 else
1324 cmd_objcopy_uboot = $(cmd_objcopy)
1325 endif
1326
1327 u-boot-nodtb.bin: u-boot FORCE
1328 $(call if_changed,objcopy_uboot)
1329 $(BOARD_SIZE_CHECK)
1330
1331 u-boot.ldr: u-boot
1332 $(CREATE_LDR_ENV)
1333 $(LDR) -T $(CONFIG_CPU) -c $@ $< $(LDR_FLAGS)
1334 $(BOARD_SIZE_CHECK)
1335
1336 # binman
1337 # ---------------------------------------------------------------------------
1338 # Use 'make BINMAN_DEBUG=1' to enable debugging
1339 # Use 'make BINMAN_VERBOSE=3' to set vebosity level
1340 default_dt := $(if $(DEVICE_TREE),$(DEVICE_TREE),$(CONFIG_DEFAULT_DEVICE_TREE))
1341
1342 quiet_cmd_binman = BINMAN $@
1343 cmd_binman = $(srctree)/tools/binman/binman $(if $(BINMAN_DEBUG),-D) \
1344 $(foreach f,$(BINMAN_TOOLPATHS),--toolpath $(f)) \
1345 --toolpath $(objtree)/tools \
1346 $(if $(BINMAN_VERBOSE),-v$(BINMAN_VERBOSE)) \
1347 build -u -d u-boot.dtb -O . -m --allow-missing \
1348 --fake-ext-blobs \
1349 -I . -I $(srctree) -I $(srctree)/board/$(BOARDDIR) \
1350 -I arch/$(ARCH)/dts -a of-list=$(CONFIG_OF_LIST) \
1351 $(foreach f,$(BINMAN_INDIRS),-I $(f)) \
1352 -a atf-bl31-path=${BL31} \
1353 -a tee-os-path=${TEE} \
1354 -a opensbi-path=${OPENSBI} \
1355 -a default-dt=$(default_dt) \
1356 -a scp-path=$(SCP) \
1357 -a spl-bss-pad=$(if $(CONFIG_SPL_SEPARATE_BSS),,1) \
1358 -a tpl-bss-pad=$(if $(CONFIG_TPL_SEPARATE_BSS),,1) \
1359 -a spl-dtb=$(CONFIG_SPL_OF_REAL) \
1360 -a tpl-dtb=$(CONFIG_TPL_OF_REAL) \
1361 -a pre-load-key-path=${PRE_LOAD_KEY_PATH} \
1362 $(BINMAN_$(@F))
1363
1364 OBJCOPYFLAGS_u-boot.ldr.hex := -I binary -O ihex
1365
1366 OBJCOPYFLAGS_u-boot.ldr.srec := -I binary -O srec
1367
1368 u-boot.ldr.hex u-boot.ldr.srec: u-boot.ldr FORCE
1369 $(call if_changed,objcopy)
1370
1371 #
1372 # U-Boot entry point, needed for booting of full-blown U-Boot
1373 # from the SPL U-Boot version.
1374 #
1375 ifndef CONFIG_SYS_UBOOT_START
1376 CONFIG_SYS_UBOOT_START := $(CONFIG_SYS_TEXT_BASE)
1377 endif
1378
1379 # Boards with more complex image requirements can provide an .its source file
1380 # or a generator script
1381 # NOTE: Please do not use this. We are migrating away from Makefile rules to use
1382 # binman instead.
1383 ifneq ($(CONFIG_SPL_FIT_SOURCE),"")
1384 U_BOOT_ITS := u-boot.its
1385 $(U_BOOT_ITS): $(subst ",,$(CONFIG_SPL_FIT_SOURCE))
1386 $(call if_changed,copy)
1387 else
1388 ifneq ($(CONFIG_USE_SPL_FIT_GENERATOR),)
1389 U_BOOT_ITS := u-boot.its
1390 ifeq ($(CONFIG_SPL_FIT_GENERATOR),"arch/arm/mach-rockchip/make_fit_atf.py")
1391 U_BOOT_ITS_DEPS += u-boot
1392 endif
1393 $(U_BOOT_ITS): $(U_BOOT_ITS_DEPS) FORCE
1394 $(srctree)/$(CONFIG_SPL_FIT_GENERATOR) \
1395 $(patsubst %,arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) > $@
1396 endif
1397 endif
1398
1399 ifdef CONFIG_SPL_LOAD_FIT
1400 MKIMAGEFLAGS_u-boot.img = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1401 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1402 -p $(CONFIG_FIT_EXTERNAL_OFFSET) \
1403 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board" -E \
1404 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(DEVICE_TREE))) \
1405 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) \
1406 $(patsubst %,-b arch/$(ARCH)/dts/%.dtbo,$(subst ",,$(CONFIG_OF_OVERLAY_LIST)))
1407 else
1408 MKIMAGEFLAGS_u-boot.img = -A $(ARCH) -T firmware -C none -O u-boot \
1409 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1410 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1411 MKIMAGEFLAGS_u-boot-ivt.img = -A $(ARCH) -T firmware_ivt -C none -O u-boot \
1412 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1413 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1414 u-boot-ivt.img: MKIMAGEOUTPUT = u-boot-ivt.img.log
1415 endif
1416
1417 MKIMAGEFLAGS_u-boot-dtb.img = $(MKIMAGEFLAGS_u-boot.img)
1418
1419 # Some boards have the kwbimage.cfg file written in advance, while some
1420 # other boards generate it on the fly during the build in the build tree.
1421 # Let's check if the file exists in the build tree first, otherwise we
1422 # fall back to use the one in the source tree.
1423 KWD_CONFIG_FILE = $(shell \
1424 if [ -f $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%) ]; then \
1425 echo -n $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1426 else \
1427 echo -n $(srctree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1428 fi)
1429
1430 MKIMAGEFLAGS_u-boot.kwb = -n $(KWD_CONFIG_FILE) \
1431 -T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE)
1432
1433 MKIMAGEFLAGS_u-boot-spl.kwb = -n $(KWD_CONFIG_FILE) \
1434 -T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1435 $(if $(KEYDIR),-k $(KEYDIR))
1436
1437 MKIMAGEFLAGS_u-boot.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1438 -R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -A $(ARCH) -T pblimage
1439
1440 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1441 UBOOT_BIN := u-boot-with-dtb.bin
1442 else
1443 UBOOT_BIN := u-boot.bin
1444 endif
1445
1446 MKIMAGEFLAGS_u-boot-lzma.img = -A $(ARCH) -T standalone -C lzma -O u-boot \
1447 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1448 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1449
1450 u-boot.bin.lzma: u-boot.bin FORCE
1451 $(call if_changed,lzma)
1452
1453 u-boot-lzma.img: u-boot.bin.lzma FORCE
1454 $(call if_changed,mkimage)
1455
1456 u-boot-dtb.img u-boot.img u-boot.kwb u-boot.pbl u-boot-ivt.img: \
1457 $(if $(CONFIG_SPL_LOAD_FIT),u-boot-nodtb.bin \
1458 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SANDBOX),dts/dt.dtb) \
1459 ,$(UBOOT_BIN)) FORCE
1460 $(call if_changed,mkimage)
1461 $(BOARD_SIZE_CHECK)
1462
1463 ifeq ($(CONFIG_SPL_LOAD_FIT_FULL),y)
1464 MKIMAGEFLAGS_u-boot.itb =
1465 else
1466 MKIMAGEFLAGS_u-boot.itb = -E
1467 endif
1468 MKIMAGEFLAGS_u-boot.itb += -B 0x8
1469
1470 ifdef U_BOOT_ITS
1471 u-boot.itb: u-boot-nodtb.bin \
1472 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SANDBOX),dts/dt.dtb) \
1473 $(U_BOOT_ITS) FORCE
1474 $(call if_changed,mkfitimage)
1475 $(BOARD_SIZE_CHECK)
1476 endif
1477
1478 u-boot-spl.kwb: u-boot.bin spl/u-boot-spl.bin FORCE
1479 $(call if_changed,mkimage)
1480
1481 u-boot.sha1: u-boot.bin
1482 tools/ubsha1 u-boot.bin
1483
1484 u-boot.dis: u-boot
1485 $(OBJDUMP) -d $< > $@
1486
1487 ifneq ($(CONFIG_SPL_PAYLOAD),)
1488 SPL_PAYLOAD := $(CONFIG_SPL_PAYLOAD:"%"=%)
1489 else
1490 SPL_PAYLOAD := u-boot.bin
1491 endif
1492
1493 SPL_IMAGE := $(CONFIG_SPL_IMAGE:"%"=%)
1494
1495 OBJCOPYFLAGS_u-boot-with-spl.bin = -I binary -O binary \
1496 --pad-to=$(CONFIG_SPL_PAD_TO)
1497 u-boot-with-spl.bin: $(SPL_IMAGE) $(SPL_PAYLOAD) FORCE
1498 $(call if_changed,pad_cat)
1499
1500
1501 ifeq ($(CONFIG_ARCH_LPC32XX)$(CONFIG_SPL),yy)
1502 MKIMAGEFLAGS_lpc32xx-spl.img = -T lpc32xximage -a $(CONFIG_SPL_TEXT_BASE)
1503
1504 lpc32xx-spl.img: spl/u-boot-spl.bin FORCE
1505 $(call if_changed,mkimage)
1506
1507 OBJCOPYFLAGS_lpc32xx-boot-0.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1508
1509 lpc32xx-boot-0.bin: lpc32xx-spl.img FORCE
1510 $(call if_changed,objcopy)
1511
1512 OBJCOPYFLAGS_lpc32xx-boot-1.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1513
1514 lpc32xx-boot-1.bin: lpc32xx-spl.img FORCE
1515 $(call if_changed,objcopy)
1516
1517 lpc32xx-full.bin: lpc32xx-boot-0.bin lpc32xx-boot-1.bin u-boot.img FORCE
1518 $(call if_changed,cat)
1519
1520 endif
1521
1522 OBJCOPYFLAGS_u-boot-with-tpl.bin = -I binary -O binary \
1523 --pad-to=$(CONFIG_TPL_PAD_TO)
1524 tpl/u-boot-with-tpl.bin: tpl/u-boot-tpl.bin u-boot.bin FORCE
1525 $(call if_changed,pad_cat)
1526
1527 SPL: spl/u-boot-spl.bin FORCE
1528 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1529
1530 ifeq ($(CONFIG_ARCH_IMX8M)$(CONFIG_ARCH_IMX8), y)
1531 ifeq ($(CONFIG_SPL_LOAD_IMX_CONTAINER), y)
1532 u-boot.cnt: u-boot.bin FORCE
1533 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1534
1535 flash.bin: spl/u-boot-spl.bin u-boot.cnt FORCE
1536 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1537 else
1538 ifeq ($(CONFIG_BINMAN),y)
1539 flash.bin: spl/u-boot-spl.bin $(INPUTS-y) FORCE
1540 $(call if_changed,binman)
1541 else
1542 flash.bin: spl/u-boot-spl.bin u-boot.itb FORCE
1543 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1544 endif
1545 endif
1546 endif
1547
1548 u-boot.uim: u-boot.bin FORCE
1549 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1550
1551 u-boot-with-spl.imx u-boot-with-nand-spl.imx: SPL $(if $(CONFIG_OF_SEPARATE),u-boot.img,u-boot.uim) FORCE
1552 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1553
1554 MKIMAGEFLAGS_u-boot.ubl = -n $(UBL_CONFIG) -T ublimage -e $(CONFIG_SYS_TEXT_BASE)
1555
1556 u-boot.ubl: u-boot-with-spl.bin FORCE
1557 $(call if_changed,mkimage)
1558
1559 MKIMAGEFLAGS_u-boot-spl.ais = -s -n $(if $(CONFIG_AIS_CONFIG_FILE), \
1560 $(srctree)/$(CONFIG_AIS_CONFIG_FILE:"%"=%),"/dev/null") \
1561 -T aisimage -e $(CONFIG_SPL_TEXT_BASE)
1562 spl/u-boot-spl.ais: spl/u-boot-spl.bin FORCE
1563 $(call if_changed,mkimage)
1564
1565 OBJCOPYFLAGS_u-boot.ais = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1566 u-boot.ais: spl/u-boot-spl.ais u-boot.img FORCE
1567 $(call if_changed,pad_cat)
1568
1569 u-boot-signed.sb: u-boot.bin spl/u-boot-spl.bin
1570 $(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot-signed.sb
1571 u-boot.sb: u-boot.bin spl/u-boot-spl.bin
1572 $(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot.sb
1573
1574 MKIMAGEFLAGS_u-boot-spl.img = -A $(ARCH) -T firmware -C none \
1575 -a $(CONFIG_SPL_TEXT_BASE) -e $(CONFIG_SPL_TEXT_BASE) -n XLOADER
1576 spl/u-boot-spl.img: spl/u-boot-spl.bin FORCE
1577 $(call if_changed,mkimage)
1578
1579 ifneq ($(CONFIG_ARCH_SOCFPGA),)
1580 quiet_cmd_gensplx4 = GENSPLX4 $@
1581 cmd_gensplx4 = $(OBJCOPY) -I binary -O binary --gap-fill=0x0 \
1582 --pad-to=$(CONFIG_SPL_PAD_TO) \
1583 spl/u-boot-spl.sfp spl/u-boot-spl.sfp && \
1584 cat spl/u-boot-spl.sfp spl/u-boot-spl.sfp \
1585 spl/u-boot-spl.sfp spl/u-boot-spl.sfp > $@ || { rm -f $@; false; }
1586 spl/u-boot-splx4.sfp: spl/u-boot-spl.sfp FORCE
1587 $(call if_changed,gensplx4)
1588
1589 quiet_cmd_socboot = SOCBOOT $@
1590 cmd_socboot = cat spl/u-boot-splx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1591 u-boot-with-spl.sfp: spl/u-boot-splx4.sfp u-boot.img FORCE
1592 $(call if_changed,socboot)
1593
1594 quiet_cmd_gensplpadx4 = GENSPLPADX4 $@
1595 cmd_gensplpadx4 = dd if=/dev/zero of=spl/u-boot-spl.pad bs=64 count=1024 ; \
1596 cat spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1597 spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1598 spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1599 spl/u-boot-spl.sfp spl/u-boot-spl.pad > $@ || \
1600 { rm -f $@ spl/u-boot-spl.pad; false; }
1601 u-boot-spl-padx4.sfp: spl/u-boot-spl.sfp FORCE
1602 $(call if_changed,gensplpadx4)
1603
1604 quiet_cmd_socnandboot = SOCNANDBOOT $@
1605 cmd_socnandboot = cat u-boot-spl-padx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1606 u-boot-with-nand-spl.sfp: u-boot-spl-padx4.sfp u-boot.img FORCE
1607 $(call if_changed,socnandboot)
1608
1609 endif
1610
1611 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1612 u-boot-with-dtb.bin: u-boot.bin u-boot.dtb \
1613 $(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR), u-boot-br.bin) FORCE
1614 $(call if_changed,binman)
1615
1616 ifeq ($(CONFIG_MPC85XX_HAVE_RESET_VECTOR),y)
1617 OBJCOPYFLAGS_u-boot-br.bin := -O binary -j .bootpg -j .resetvec
1618 u-boot-br.bin: u-boot FORCE
1619 $(call if_changed,objcopy)
1620 endif
1621 endif
1622
1623 quiet_cmd_ldr = LD $@
1624 cmd_ldr = $(LD) $(LDFLAGS_$(@F)) \
1625 $(filter-out FORCE,$^) -o $@
1626
1627 ifdef CONFIG_X86
1628 OBJCOPYFLAGS_u-boot-x86-start16.bin := -O binary -j .start16
1629 u-boot-x86-start16.bin: u-boot FORCE
1630 $(call if_changed,objcopy)
1631
1632 OBJCOPYFLAGS_u-boot-x86-reset16.bin := -O binary -j .resetvec
1633 u-boot-x86-reset16.bin: u-boot FORCE
1634 $(call if_changed,objcopy)
1635
1636 endif # CONFIG_X86
1637
1638 OBJCOPYFLAGS_u-boot-app.efi := $(OBJCOPYFLAGS_EFI)
1639 u-boot-app.efi: u-boot FORCE
1640 $(call if_changed,zobjcopy)
1641
1642 u-boot.bin.o: u-boot.bin FORCE
1643 $(call if_changed,efipayload)
1644
1645 u-boot-payload.lds: $(LDSCRIPT_EFI) FORCE
1646 $(call if_changed_dep,cpp_lds)
1647
1648 # Rule to link the EFI payload which contains a stub and a U-Boot binary
1649 quiet_cmd_u-boot_payload ?= LD $@
1650 cmd_u-boot_payload ?= $(LD) $(LDFLAGS_EFI_PAYLOAD) -o $@ \
1651 -T u-boot-payload.lds arch/x86/cpu/call32.o \
1652 lib/efi/efi.o lib/efi/efi_stub.o u-boot.bin.o \
1653 $(addprefix arch/$(ARCH)/lib/,$(EFISTUB))
1654
1655 u-boot-payload: u-boot.bin.o u-boot-payload.lds FORCE
1656 $(call if_changed,u-boot_payload)
1657
1658 OBJCOPYFLAGS_u-boot-payload.efi := $(OBJCOPYFLAGS_EFI)
1659 u-boot-payload.efi: u-boot-payload FORCE
1660 $(call if_changed,zobjcopy)
1661
1662 u-boot-img.bin: spl/u-boot-spl.bin u-boot.img FORCE
1663 $(call if_changed,cat)
1664
1665 #Add a target to create boot binary having SPL binary in PBI format
1666 #concatenated with u-boot binary. It is need by PowerPC SoC having
1667 #internal SRAM <= 512KB.
1668 MKIMAGEFLAGS_u-boot-spl.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1669 -R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage \
1670 -A $(ARCH) -a $(CONFIG_SPL_TEXT_BASE)
1671
1672 spl/u-boot-spl.pbl: spl/u-boot-spl.bin FORCE
1673 $(call if_changed,mkimage)
1674
1675 ifeq ($(ARCH),arm)
1676 UBOOT_BINLOAD := u-boot.img
1677 else
1678 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1679 UBOOT_BINLOAD := u-boot-with-dtb.bin
1680 else
1681 UBOOT_BINLOAD := u-boot.bin
1682 endif
1683 endif
1684
1685 OBJCOPYFLAGS_u-boot-with-spl-pbl.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO) \
1686 --gap-fill=0xff
1687
1688 u-boot-with-spl-pbl.bin: spl/u-boot-spl.pbl $(UBOOT_BINLOAD) FORCE
1689 $(call if_changed,pad_cat)
1690
1691 # PPC4xx needs the SPL at the end of the image, since the reset vector
1692 # is located at 0xfffffffc. So we can't use the "u-boot-img.bin" target
1693 # and need to introduce a new build target with the full blown U-Boot
1694 # at the start padded up to the start of the SPL image. And then concat
1695 # the SPL image to the end.
1696
1697 OBJCOPYFLAGS_u-boot-img-spl-at-end.bin := -I binary -O binary \
1698 --pad-to=$(CONFIG_UBOOT_PAD_TO) --gap-fill=0xff
1699 u-boot-img-spl-at-end.bin: u-boot.img spl/u-boot-spl.bin FORCE
1700 $(call if_changed,pad_cat)
1701
1702 quiet_cmd_u-boot-elf ?= LD $@
1703 cmd_u-boot-elf ?= $(LD) u-boot-elf.o -o $@ \
1704 $(if $(CONFIG_SYS_BIG_ENDIAN),-EB,-EL) \
1705 -T u-boot-elf.lds --defsym=$(CONFIG_PLATFORM_ELFENTRY)=$(CONFIG_SYS_TEXT_BASE) \
1706 -Ttext=$(CONFIG_SYS_TEXT_BASE)
1707 u-boot.elf: u-boot.bin u-boot-elf.lds
1708 $(Q)$(OBJCOPY) -I binary $(PLATFORM_ELFFLAGS) $< u-boot-elf.o
1709 $(call if_changed,u-boot-elf)
1710
1711 u-boot-elf.lds: arch/u-boot-elf.lds prepare FORCE
1712 $(call if_changed_dep,cpp_lds)
1713
1714 # MediaTek's ARM-based u-boot needs a header to contains its load address
1715 # which is parsed by the BootROM.
1716 # If the SPL build is enabled, the header will be added to the spl binary,
1717 # and the spl binary and the u-boot.img will be combined into one file.
1718 # Otherwise the header will be added to the u-boot.bin directly.
1719
1720 ifeq ($(CONFIG_SPL),y)
1721 spl/u-boot-spl-mtk.bin: spl/u-boot-spl
1722
1723 u-boot-mtk.bin: u-boot-with-spl.bin
1724 $(call if_changed,copy)
1725 else
1726 MKIMAGEFLAGS_u-boot-mtk.bin = -T mtk_image \
1727 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1728 -n "$(patsubst "%",%,$(CONFIG_MTK_BROM_HEADER_INFO))"
1729
1730 u-boot-mtk.bin: u-boot.bin FORCE
1731 $(call if_changed,mkimage)
1732 endif
1733
1734 quiet_cmd_endian_swap = SWAP $@
1735 cmd_endian_swap = $(srctree)/tools/endian-swap.py $< $@
1736
1737 u-boot-swap.bin: u-boot.bin FORCE
1738 $(call if_changed,endian_swap)
1739
1740 ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(ARCH)/Makefile.postlink)
1741
1742 # Generate linker list symbols references to force compiler to not optimize
1743 # them away when compiling with LTO
1744 ifdef CONFIG_LTO
1745 u-boot-keep-syms-lto := keep-syms-lto.o
1746 u-boot-keep-syms-lto_c := $(patsubst %.o,%.c,$(u-boot-keep-syms-lto))
1747
1748 quiet_cmd_keep_syms_lto = KSL $@
1749 cmd_keep_syms_lto = \
1750 $(srctree)/scripts/gen_ll_addressable_symbols.sh $(NM) $^ > $@
1751
1752 quiet_cmd_keep_syms_lto_cc = KSLCC $@
1753 cmd_keep_syms_lto_cc = \
1754 $(CC) $(filter-out $(LTO_CFLAGS),$(c_flags)) -c -o $@ $<
1755
1756 $(u-boot-keep-syms-lto_c): $(u-boot-main)
1757 $(call if_changed,keep_syms_lto)
1758 $(u-boot-keep-syms-lto): $(u-boot-keep-syms-lto_c)
1759 $(call if_changed,keep_syms_lto_cc)
1760 else
1761 u-boot-keep-syms-lto :=
1762 endif
1763
1764 # Rule to link u-boot
1765 # May be overridden by arch/$(ARCH)/config.mk
1766 ifdef CONFIG_LTO
1767 quiet_cmd_u-boot__ ?= LTO $@
1768 cmd_u-boot__ ?= \
1769 $(CC) -nostdlib -nostartfiles \
1770 $(LTO_FINAL_LDFLAGS) $(c_flags) \
1771 $(KBUILD_LDFLAGS:%=-Wl,%) $(LDFLAGS_u-boot:%=-Wl,%) -o $@ \
1772 -T u-boot.lds $(u-boot-init) \
1773 -Wl,--whole-archive \
1774 $(u-boot-main) \
1775 $(u-boot-keep-syms-lto) \
1776 $(PLATFORM_LIBS) \
1777 -Wl,--no-whole-archive \
1778 -Wl,-Map,u-boot.map; \
1779 $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1780 else
1781 quiet_cmd_u-boot__ ?= LD $@
1782 cmd_u-boot__ ?= $(LD) $(KBUILD_LDFLAGS) $(LDFLAGS_u-boot) -o $@ \
1783 -T u-boot.lds $(u-boot-init) \
1784 --whole-archive \
1785 $(u-boot-main) \
1786 --no-whole-archive \
1787 $(PLATFORM_LIBS) -Map u-boot.map; \
1788 $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1789 endif
1790
1791 quiet_cmd_smap = GEN common/system_map.o
1792 cmd_smap = \
1793 smap=`$(call SYSTEM_MAP,u-boot) | \
1794 awk '$$2 ~ /[tTwW]/ {printf $$1 $$3 "\\\\000"}'` ; \
1795 $(CC) $(c_flags) -DSYSTEM_MAP="\"$${smap}\"" \
1796 -c $(srctree)/common/system_map.c -o common/system_map.o
1797
1798 u-boot: $(u-boot-init) $(u-boot-main) $(u-boot-keep-syms-lto) u-boot.lds FORCE
1799 +$(call if_changed,u-boot__)
1800 ifeq ($(CONFIG_KALLSYMS),y)
1801 $(call cmd,smap)
1802 $(call cmd,u-boot__) common/system_map.o
1803 endif
1804
1805 ifeq ($(CONFIG_RISCV),y)
1806 @tools/prelink-riscv $@ 0
1807 endif
1808
1809 quiet_cmd_sym ?= SYM $@
1810 cmd_sym ?= $(OBJDUMP) -t $< > $@
1811 u-boot.sym: u-boot FORCE
1812 $(call if_changed,sym)
1813
1814 # Environment processing
1815 # ---------------------------------------------------------------------------
1816
1817 # Directory where we expect the .env file, if it exists
1818 ENV_DIR := $(srctree)/board/$(BOARDDIR)
1819
1820 # Basename of .env file, stripping quotes
1821 ENV_SOURCE_FILE := $(CONFIG_ENV_SOURCE_FILE:"%"=%)
1822
1823 # Filename of .env file
1824 ENV_FILE_CFG := $(ENV_DIR)/$(ENV_SOURCE_FILE).env
1825
1826 # Default filename, if CONFIG_ENV_SOURCE_FILE is empty
1827 ENV_FILE_BOARD := $(ENV_DIR)/$(CONFIG_SYS_BOARD:"%"=%).env
1828
1829 # Select between the CONFIG_ENV_SOURCE_FILE and the default one
1830 ENV_FILE := $(if $(ENV_SOURCE_FILE),$(ENV_FILE_CFG),$(wildcard $(ENV_FILE_BOARD)))
1831
1832 # Run the environment text file through the preprocessor, but only if it is
1833 # non-empty, to save time and possible build errors if something is wonky with
1834 # the board.
1835 # If there is no ENV_FILE, produce an empty output file, to prevent a previous
1836 # build's file being used in the case of in-tree builds.
1837 quiet_cmd_gen_envp = ENVP $@
1838 cmd_gen_envp = \
1839 if [ -s "$(ENV_FILE)" ]; then \
1840 $(CPP) -P $(CFLAGS) -x assembler-with-cpp -D__ASSEMBLY__ \
1841 -D__UBOOT_CONFIG__ \
1842 -I . -I include -I $(srctree)/include \
1843 -include linux/kconfig.h -include include/config.h \
1844 -I$(srctree)/arch/$(ARCH)/include \
1845 $< -o $@; \
1846 else \
1847 rm -f $@; \
1848 touch $@ ; \
1849 fi
1850 include/generated/env.in: include/generated/env.txt FORCE
1851 $(call cmd,gen_envp)
1852
1853 # Regenerate the environment if it changes
1854 # We use 'wildcard' since the file is not required to exist (at present), in
1855 # which case we don't want this dependency, but instead should create an empty
1856 # file
1857 # This rule is useful since it shows the source file for the environment
1858 quiet_cmd_envc = ENVC $@
1859 cmd_envc = \
1860 if [ -f "$<" ]; then \
1861 cat $< > $@; \
1862 elif [ -n "$(ENV_SOURCE_FILE)" ]; then \
1863 echo "Missing file $(ENV_FILE_CFG)"; \
1864 else \
1865 touch $@ ; \
1866 fi
1867
1868 include/generated/env.txt: $(wildcard $(ENV_FILE)) FORCE
1869 $(call cmd,envc)
1870
1871 # Write out the resulting environment, converted to a C string
1872 quiet_cmd_gen_envt = ENVT $@
1873 cmd_gen_envt = \
1874 awk -f $(srctree)/scripts/env2string.awk $< >$@
1875 $(env_h): include/generated/env.in
1876 $(call cmd,gen_envt)
1877
1878 # ---------------------------------------------------------------------------
1879
1880 # The actual objects are generated when descending,
1881 # make sure no implicit rule kicks in
1882 $(sort $(u-boot-init) $(u-boot-main)): $(u-boot-dirs) ;
1883
1884 # Handle descending into subdirectories listed in $(u-boot-dirs)
1885 # Preset locale variables to speed up the build process. Limit locale
1886 # tweaks to this spot to avoid wrong language settings when running
1887 # make menuconfig etc.
1888 # Error messages still appears in the original language
1889
1890 PHONY += $(u-boot-dirs)
1891 $(u-boot-dirs): prepare scripts
1892 $(Q)$(MAKE) $(build)=$@
1893
1894 tools: prepare
1895 # The "tools" are needed early
1896 $(filter-out tools, $(u-boot-dirs)): tools
1897 # The "examples" conditionally depend on U-Boot (say, when USE_PRIVATE_LIBGCC
1898 # is "yes"), so compile examples after U-Boot is compiled.
1899 examples: $(filter-out examples, $(u-boot-dirs))
1900
1901 define filechk_uboot.release
1902 echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
1903 endef
1904
1905 # Store (new) UBOOTRELEASE string in include/config/uboot.release
1906 include/config/uboot.release: include/config/auto.conf FORCE
1907 $(call filechk,uboot.release)
1908
1909
1910 # Things we need to do before we recursively start building the kernel
1911 # or the modules are listed in "prepare".
1912 # A multi level approach is used. prepareN is processed before prepareN-1.
1913 # archprepare is used in arch Makefiles and when processed asm symlink,
1914 # version.h and scripts_basic is processed / created.
1915
1916 # Listed in dependency order
1917 PHONY += prepare archprepare prepare0 prepare1 prepare2 prepare3
1918
1919 # prepare3 is used to check if we are building in a separate output directory,
1920 # and if so do:
1921 # 1) Check that make has not been executed in the kernel src $(srctree)
1922 prepare3: include/config/uboot.release
1923 ifneq ($(KBUILD_SRC),)
1924 @$(kecho) ' Using $(srctree) as source for U-Boot'
1925 $(Q)if [ -f $(srctree)/.config -o -d $(srctree)/include/config ]; then \
1926 echo >&2 " $(srctree) is not clean, please run 'make mrproper'"; \
1927 echo >&2 " in the '$(srctree)' directory.";\
1928 /bin/false; \
1929 fi;
1930 endif
1931
1932 # prepare2 creates a makefile if using a separate output directory
1933 prepare2: prepare3 outputmakefile cfg
1934
1935 prepare1: prepare2 $(version_h) $(timestamp_h) $(dt_h) $(env_h) \
1936 include/config/auto.conf
1937 ifeq ($(wildcard $(LDSCRIPT)),)
1938 @echo >&2 " Could not find linker script."
1939 @/bin/false
1940 endif
1941
1942 ifeq ($(CONFIG_USE_DEFAULT_ENV_FILE),y)
1943 prepare1: $(defaultenv_h)
1944
1945 envtools: $(defaultenv_h)
1946 endif
1947
1948 archprepare: prepare1 scripts_basic
1949
1950 prepare0: archprepare FORCE
1951 $(Q)$(MAKE) $(build)=.
1952
1953 # All the preparing..
1954 prepare: prepare0
1955
1956 # Generate some files
1957 # ---------------------------------------------------------------------------
1958
1959 # Use sed to remove leading zeros from PATCHLEVEL to avoid using octal numbers
1960 define filechk_version.h
1961 (echo \#define PLAIN_VERSION \"$(UBOOTRELEASE)\"; \
1962 echo \#define U_BOOT_VERSION \"U-Boot \" PLAIN_VERSION; \
1963 echo \#define U_BOOT_VERSION_NUM $(VERSION); \
1964 echo \#define U_BOOT_VERSION_NUM_PATCH $$(echo $(PATCHLEVEL) | \
1965 sed -e "s/^0*//"); \
1966 echo \#define CC_VERSION_STRING \"$$(LC_ALL=C $(CC) --version | head -n 1)\"; \
1967 echo \#define LD_VERSION_STRING \"$$(LC_ALL=C $(LD) --version | head -n 1)\"; )
1968 endef
1969
1970 # The SOURCE_DATE_EPOCH mechanism requires a date that behaves like GNU date.
1971 # The BSD date on the other hand behaves different and would produce errors
1972 # with the misused '-d' switch. Respect that and search a working date with
1973 # well known pre- and suffixes for the GNU variant of date.
1974 define filechk_timestamp.h
1975 (if test -n "$${SOURCE_DATE_EPOCH}"; then \
1976 SOURCE_DATE="@$${SOURCE_DATE_EPOCH}"; \
1977 DATE=""; \
1978 for date in gdate date.gnu date; do \
1979 $${date} -u -d "$${SOURCE_DATE}" >/dev/null 2>&1 && DATE="$${date}"; \
1980 done; \
1981 if test -n "$${DATE}"; then \
1982 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_DATE "%b %d %C%y"'; \
1983 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TIME "%T"'; \
1984 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TZ "%z"'; \
1985 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_EPOCH %s'; \
1986 else \
1987 return 42; \
1988 fi; \
1989 else \
1990 LC_ALL=C date +'#define U_BOOT_DATE "%b %d %C%y"'; \
1991 LC_ALL=C date +'#define U_BOOT_TIME "%T"'; \
1992 LC_ALL=C date +'#define U_BOOT_TZ "%z"'; \
1993 LC_ALL=C date +'#define U_BOOT_EPOCH %s'; \
1994 fi)
1995 endef
1996
1997 define filechk_defaultenv.h
1998 ( { grep -v '^#' | grep -v '^$$' || true ; echo '' ; } | \
1999 tr '\n' '\0' | \
2000 sed -e 's/\\\x0\s*//g' | \
2001 xxd -i ; )
2002 endef
2003
2004 define filechk_dt.h
2005 (if test -n "$${DEVICE_TREE}"; then \
2006 echo \#define DEVICE_TREE \"$(DEVICE_TREE)\"; \
2007 else \
2008 echo \#define DEVICE_TREE CONFIG_DEFAULT_DEVICE_TREE; \
2009 fi)
2010 endef
2011
2012 $(version_h): include/config/uboot.release FORCE
2013 $(call filechk,version.h)
2014
2015 $(timestamp_h): $(srctree)/Makefile FORCE
2016 $(call filechk,timestamp.h)
2017
2018 $(dt_h): $(srctree)/Makefile FORCE
2019 $(call filechk,dt.h)
2020
2021 $(defaultenv_h): $(CONFIG_DEFAULT_ENV_FILE:"%"=%) FORCE
2022 $(call filechk,defaultenv.h)
2023
2024 # ---------------------------------------------------------------------------
2025 # Devicetree files
2026
2027 ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/boot/dts/),)
2028 dtstree := arch/$(SRCARCH)/boot/dts
2029 endif
2030
2031 ifneq ($(dtstree),)
2032
2033 %.dtb: prepare3 scripts_dtc
2034 $(Q)$(MAKE) $(build)=$(dtstree) $(dtstree)/$@
2035
2036 PHONY += dtbs dtbs_install
2037 dtbs: prepare3 scripts_dtc
2038 $(Q)$(MAKE) $(build)=$(dtstree)
2039
2040 dtbs_install:
2041 $(Q)$(MAKE) $(dtbinst)=$(dtstree)
2042
2043 ifdef CONFIG_OF_EARLY_FLATTREE
2044 all: dtbs
2045 endif
2046
2047 endif
2048
2049 # Check dtc and pylibfdt, if DTC is provided, else build them
2050 PHONY += scripts_dtc
2051 scripts_dtc: scripts_basic
2052 $(Q)if test "$(DTC)" = "$(DTC_INTREE)"; then \
2053 $(MAKE) $(build)=scripts/dtc; \
2054 else \
2055 if ! $(DTC) -v >/dev/null; then \
2056 echo '*** Failed to check dtc version: $(DTC)'; \
2057 false; \
2058 else \
2059 if test "$(call dtc-version)" -lt $(DTC_MIN_VERSION); then \
2060 echo '*** Your dtc is too old, please upgrade to dtc $(DTC_MIN_VERSION) or newer'; \
2061 false; \
2062 else \
2063 if [ -n "$(CONFIG_PYLIBFDT)" ]; then \
2064 if ! echo "import libfdt" | $(PYTHON3) 2>/dev/null; then \
2065 echo '*** pylibfdt does not seem to be available with $(PYTHON3)'; \
2066 false; \
2067 fi; \
2068 fi; \
2069 fi; \
2070 fi; \
2071 fi
2072
2073 # ---------------------------------------------------------------------------
2074 quiet_cmd_cpp_lds = LDS $@
2075 cmd_cpp_lds = $(CPP) -Wp,-MD,$(depfile) $(cpp_flags) $(LDPPFLAGS) \
2076 -D__ASSEMBLY__ -x assembler-with-cpp -std=c99 -P -o $@ $<
2077
2078 u-boot.lds: $(LDSCRIPT) prepare FORCE
2079 $(call if_changed_dep,cpp_lds)
2080
2081 spl/u-boot-spl.bin: spl/u-boot-spl
2082 @:
2083 $(SPL_SIZE_CHECK)
2084
2085 spl/u-boot-spl-dtb.bin: spl/u-boot-spl
2086 @:
2087
2088 spl/u-boot-spl-dtb.hex: spl/u-boot-spl
2089 @:
2090
2091 spl/u-boot-spl: tools prepare $(if $(CONFIG_SPL_OF_CONTROL),dts/dt.dtb)
2092 $(Q)$(MAKE) obj=spl -f $(srctree)/scripts/Makefile.spl all
2093
2094 spl/sunxi-spl.bin: spl/u-boot-spl
2095 @:
2096
2097 spl/sunxi-spl-with-ecc.bin: spl/sunxi-spl.bin
2098 @:
2099
2100 spl/u-boot-spl.sfp: spl/u-boot-spl
2101 @:
2102
2103 spl/boot.bin: spl/u-boot-spl
2104 @:
2105
2106 tpl/u-boot-tpl.bin: tpl/u-boot-tpl
2107 @:
2108 $(TPL_SIZE_CHECK)
2109
2110 tpl/u-boot-tpl: tools prepare $(if $(CONFIG_TPL_OF_CONTROL),dts/dt.dtb)
2111 $(Q)$(MAKE) obj=tpl -f $(srctree)/scripts/Makefile.spl all
2112
2113 vpl/u-boot-vpl.bin: vpl/u-boot-vpl
2114 @:
2115 $(VPL_SIZE_CHECK)
2116
2117 vpl/u-boot-vpl: tools prepare $(if $(CONFIG_TPL_OF_CONTROL),dts/dt.dtb)
2118 $(Q)$(MAKE) obj=vpl -f $(srctree)/scripts/Makefile.spl all
2119
2120 TAG_SUBDIRS := $(patsubst %,$(srctree)/%,$(u-boot-dirs) include)
2121
2122 FIND := find
2123 FINDFLAGS := -L
2124
2125 tags ctags:
2126 ctags -w -o ctags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
2127 -name '*.[chS]' -print`
2128 ln -s ctags tags
2129
2130 etags:
2131 etags -a -o etags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
2132 -name '*.[chS]' -print`
2133 cscope:
2134 $(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) -name '*.[chS]' -print > \
2135 cscope.files
2136 @find $(TAG_SUBDIRS) -name '*.[chS]' -type l -print | \
2137 grep -xvf - cscope.files > cscope.files.no-symlinks; \
2138 mv cscope.files.no-symlinks cscope.files
2139 cscope -b -q -k
2140
2141 SYSTEM_MAP = \
2142 $(NM) $1 | \
2143 grep -v '\(compiled\)\|\(\.o$$\)\|\( [aUw] \)\|\(\.\.ng$$\)\|\(LASH[RL]DI\)' | \
2144 LC_ALL=C sort
2145 System.map: u-boot
2146 @$(call SYSTEM_MAP,$<) > $@
2147
2148 #########################################################################
2149
2150 # ARM relocations should all be R_ARM_RELATIVE (32-bit) or
2151 # R_AARCH64_RELATIVE (64-bit).
2152 checkarmreloc: u-boot
2153 @RELOC="`$(CROSS_COMPILE)readelf -r -W $< | cut -d ' ' -f 4 | \
2154 grep R_A | sort -u`"; \
2155 if test "$$RELOC" != "R_ARM_RELATIVE" -a \
2156 "$$RELOC" != "R_AARCH64_RELATIVE"; then \
2157 echo "$< contains unexpected relocations: $$RELOC"; \
2158 false; \
2159 fi
2160
2161 tools/version.h: include/version.h
2162 $(Q)mkdir -p $(dir $@)
2163 $(call if_changed,copy)
2164
2165 envtools: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2166 $(Q)$(MAKE) $(build)=tools/env
2167
2168 tools-only: export TOOLS_ONLY=y
2169 tools-only: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2170 $(Q)$(MAKE) $(build)=tools
2171
2172 tools-all: export HOST_TOOLS_ALL=y
2173 tools-all: envtools tools ;
2174
2175 cross_tools: export CROSS_BUILD_TOOLS=y
2176 cross_tools: tools ;
2177
2178 .PHONY : CHANGELOG
2179 CHANGELOG:
2180 git log --no-merges U-Boot-1_1_5.. | \
2181 unexpand -a | sed -e 's/\s\s*$$//' > $@
2182
2183 #########################################################################
2184
2185 ###
2186 # Cleaning is done on three levels.
2187 # make clean Delete most generated files
2188 # Leave enough to build external modules
2189 # make mrproper Delete the current configuration, and all generated files
2190 # make distclean Remove editor backup files, patch leftover files and the like
2191
2192 # Directories & files removed with 'make clean'
2193 CLEAN_DIRS += $(MODVERDIR) \
2194 $(foreach d, spl tpl, $(patsubst %,$d/%, \
2195 $(filter-out include, $(shell ls -1 $d 2>/dev/null))))
2196
2197 CLEAN_FILES += include/bmp_logo.h include/bmp_logo_data.h \
2198 include/generated/env.* drivers/video/u_boot_logo.S \
2199 tools/version.h u-boot* MLO* SPL System.map fit-dtb.blob* \
2200 u-boot-ivt.img.log u-boot-dtb.imx.log SPL.log u-boot.imx.log \
2201 lpc32xx-* bl31.c bl31.elf bl31_*.bin image.map tispl.bin* \
2202 idbloader.img flash.bin flash.log defconfig keep-syms-lto.c \
2203 mkimage-out.spl.mkimage mkimage.spl.mkimage imx-boot.map \
2204 itb.fit.fit itb.fit.itb itb.map spl.map mkimage-out.rom.mkimage \
2205 mkimage.rom.mkimage rom.map simple-bin.map
2206
2207 # Directories & files removed with 'make mrproper'
2208 MRPROPER_DIRS += include/config include/generated spl tpl \
2209 .tmp_objdiff doc/output include/asm
2210
2211 # Remove include/asm symlink created by U-Boot before v2014.01
2212 MRPROPER_FILES += .config .config.old include/autoconf.mk* include/config.h \
2213 ctags etags tags TAGS cscope* GPATH GTAGS GRTAGS GSYMS \
2214 drivers/video/fonts/*.S include/asm
2215
2216 # clean - Delete most, but leave enough to build external modules
2217 #
2218 clean: rm-dirs := $(CLEAN_DIRS)
2219 clean: rm-files := $(CLEAN_FILES)
2220
2221 clean-dirs := $(foreach f,$(u-boot-alldirs),$(if $(wildcard $(srctree)/$f/Makefile),$f))
2222
2223 clean-dirs := $(addprefix _clean_, $(clean-dirs))
2224
2225 PHONY += $(clean-dirs) clean archclean
2226 $(clean-dirs):
2227 $(Q)$(MAKE) $(clean)=$(patsubst _clean_%,%,$@)
2228
2229 clean: $(clean-dirs)
2230 $(call cmd,rmdirs)
2231 $(call cmd,rmfiles)
2232 @find $(if $(KBUILD_EXTMOD), $(KBUILD_EXTMOD), .) $(RCS_FIND_IGNORE) \
2233 \( -name '*.[oas]' -o -name '*.ko' -o -name '.*.cmd' \
2234 -o -name '*.ko.*' -o -name '*.su' -o -name '*.pyc' \
2235 -o -name '.*.d' -o -name '.*.tmp' -o -name '*.mod.c' \
2236 -o -name '*.lex.c' -o -name '*.tab.[ch]' \
2237 -o -name '*.asn1.[ch]' \
2238 -o -name '*.symtypes' -o -name 'modules.order' \
2239 -o -name modules.builtin -o -name '.tmp_*.o.*' \
2240 -o -name 'dsdt_generated.aml' -o -name 'dsdt_generated.asl.tmp' \
2241 -o -name 'dsdt_generated.c' \
2242 -o -name '*.efi' -o -name '*.gcno' -o -name '*.so' \) \
2243 -type f -print | xargs rm -f
2244
2245 # mrproper - Delete all generated files, including .config
2246 #
2247 mrproper: rm-dirs := $(wildcard $(MRPROPER_DIRS))
2248 mrproper: rm-files := $(wildcard $(MRPROPER_FILES))
2249 mrproper-dirs := $(addprefix _mrproper_,scripts)
2250
2251 PHONY += $(mrproper-dirs) mrproper archmrproper
2252 $(mrproper-dirs):
2253 $(Q)$(MAKE) $(clean)=$(patsubst _mrproper_%,%,$@)
2254
2255 mrproper: clean $(mrproper-dirs)
2256 $(call cmd,rmdirs)
2257 $(call cmd,rmfiles)
2258 @rm -f arch/*/include/asm/arch
2259
2260 # distclean
2261 #
2262 PHONY += distclean
2263
2264 distclean: mrproper
2265 @find $(srctree) $(RCS_FIND_IGNORE) \
2266 \( -name '*.orig' -o -name '*.rej' -o -name '*~' \
2267 -o -name '*.bak' -o -name '#*#' -o -name '.*.orig' \
2268 -o -name '.*.rej' -o -name '*%' -o -name 'core' \
2269 -o -name '*.pyc' \) \
2270 -type f -print | xargs rm -f
2271 @rm -f boards.cfg CHANGELOG
2272
2273 # See doc/develop/python_cq.rst
2274 PHONY += pylint pylint_err
2275 PYLINT_BASE := scripts/pylint.base
2276 PYLINT_CUR := pylint.cur
2277 PYLINT_DIFF := pylint.diff
2278 pylint:
2279 $(Q)echo "Running pylint on all files (summary in $(PYLINT_CUR); output in pylint.out/)"
2280 $(Q)mkdir -p pylint.out
2281 $(Q)rm -f pylint.out/out*
2282 $(Q)find tools test -name "*.py" \
2283 | xargs -n1 -P$(shell nproc 2>/dev/null || echo 1) \
2284 sh -c 'pylint --reports=y --exit-zero -f parseable --ignore-imports=yes $$@ > pylint.out/$$(echo $$@ | tr / _ | sed s/.py//)' _
2285 $(Q)rm -f $(PYLINT_CUR)
2286 $(Q)( cd pylint.out; for f in *; do \
2287 sed -ne "s/Your code has been rated at \([-0-9.]*\).*/$$f \1/p" $$f; \
2288 done ) | sort > $(PYLINT_CUR)
2289 $(Q)base=$$(mktemp) cur=$$(mktemp); cut -d' ' -f1 $(PYLINT_BASE) >$$base; \
2290 cut -d' ' -f1 $(PYLINT_CUR) >$$cur; \
2291 comm -3 $$base $$cur > $(PYLINT_DIFF); \
2292 if [ -s $(PYLINT_DIFF) ]; then \
2293 echo "Files have been added/removed. Try:\n\tcp $(PYLINT_CUR) $(PYLINT_BASE)"; \
2294 echo; \
2295 echo "Added files:"; \
2296 comm -13 $$base $$cur; \
2297 echo; \
2298 echo "Removed files:"; \
2299 comm -23 $$base $$cur; \
2300 false; \
2301 else \
2302 rm $$base $$cur $(PYLINT_DIFF); \
2303 fi
2304 $(Q)bad=false; while read base_file base_val <&3 && read cur_file cur_val <&4; do \
2305 if awk "BEGIN {exit !($$cur_val < $$base_val)}"; then \
2306 echo "$$base_file: Score was $$base_val, now $$cur_val"; \
2307 bad=true; fi; \
2308 done 3<$(PYLINT_BASE) 4<$(PYLINT_CUR); \
2309 if $$bad; then \
2310 echo "Some files have regressed, please fix"; \
2311 false; \
2312 else \
2313 echo "No pylint regressions"; \
2314 fi
2315
2316 # Check for errors only
2317 pylint_err:
2318 $(Q)pylint -E -j 0 --ignore-imports=yes \
2319 $(shell find tools test -name "*.py")
2320
2321 backup:
2322 F=`basename $(srctree)` ; cd .. ; \
2323 gtar --force-local -zcvf `LC_ALL=C date "+$$F-%Y-%m-%d-%T.tar.gz"` $$F
2324
2325 help:
2326 @echo 'Cleaning targets:'
2327 @echo ' clean - Remove most generated files but keep the config'
2328 @echo ' mrproper - Remove all generated files + config + various backup files'
2329 @echo ' distclean - mrproper + remove editor backup and patch files'
2330 @echo ''
2331 @echo 'Configuration targets:'
2332 @$(MAKE) -f $(srctree)/scripts/kconfig/Makefile help
2333 @echo ''
2334 @echo 'Test targets:'
2335 @echo ''
2336 @echo ' check - Run all automated tests that use sandbox'
2337 @echo ' qcheck - Run quick automated tests that use sandbox'
2338 @echo ' tcheck - Run quick automated tests on tools'
2339 @echo ' pylint - Run pylint on all Python files'
2340 @echo ''
2341 @echo 'Other generic targets:'
2342 @echo ' all - Build all necessary images depending on configuration'
2343 @echo ' tests - Build U-Boot for sandbox and run tests'
2344 @echo '* u-boot - Build the bare u-boot'
2345 @echo ' dir/ - Build all files in dir and below'
2346 @echo ' dir/file.[oisS] - Build specified target only'
2347 @echo ' dir/file.lst - Build specified mixed source/assembly target only'
2348 @echo ' (requires a recent binutils and recent build (System.map))'
2349 @echo ' tags/ctags - Generate ctags file for editors'
2350 @echo ' etags - Generate etags file for editors'
2351 @echo ' cscope - Generate cscope index'
2352 @echo ' ubootrelease - Output the release version string (use with make -s)'
2353 @echo ' ubootversion - Output the version stored in Makefile (use with make -s)'
2354 @echo " cfg - Don't build, just create the .cfg files"
2355 @echo " envtools - Build only the target-side environment tools"
2356 @echo ''
2357 @echo 'Static analysers'
2358 @echo ' checkstack - Generate a list of stack hogs'
2359 @echo ' coccicheck - Execute static code analysis with Coccinelle'
2360 @echo ''
2361 @echo 'Documentation targets:'
2362 @$(MAKE) -f $(srctree)/doc/Makefile dochelp
2363 @echo ''
2364 @echo ' make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
2365 @echo ' make V=2 [targets] 2 => give reason for rebuild of target'
2366 @echo ' make O=dir [targets] Locate all output files in "dir", including .config'
2367 @echo ' make C=1 [targets] Check all c source with $$CHECK (sparse by default)'
2368 @echo ' make C=2 [targets] Force check of all c source with $$CHECK'
2369 @echo ' make RECORDMCOUNT_WARN=1 [targets] Warn about ignored mcount sections'
2370 @echo ' make W=n [targets] Enable extra gcc checks, n=1,2,3 where'
2371 @echo ' 1: warnings which may be relevant and do not occur too often'
2372 @echo ' 2: warnings which occur quite often but may still be relevant'
2373 @echo ' 3: more obscure warnings, can most likely be ignored'
2374 @echo ' Multiple levels can be combined with W=12 or W=123'
2375 @echo ''
2376 @echo 'Execute "make" or "make all" to build all targets marked with [*] '
2377 @echo 'For further info see the ./README file'
2378
2379 tests check:
2380 $(srctree)/test/run
2381
2382 qcheck:
2383 $(srctree)/test/run quick
2384
2385 tcheck:
2386 $(srctree)/test/run tools
2387
2388 # Documentation targets
2389 # ---------------------------------------------------------------------------
2390 DOC_TARGETS := xmldocs latexdocs pdfdocs htmldocs epubdocs cleandocs \
2391 linkcheckdocs dochelp refcheckdocs
2392 PHONY += $(DOC_TARGETS)
2393 $(DOC_TARGETS): scripts_basic FORCE
2394 $(Q)$(MAKE) $(build)=doc $@
2395
2396 PHONY += checkstack ubootrelease ubootversion
2397
2398 checkstack:
2399 $(OBJDUMP) -d u-boot $$(find . -name u-boot-spl) | \
2400 $(PERL) $(src)/scripts/checkstack.pl $(ARCH)
2401
2402 ubootrelease:
2403 @echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
2404
2405 ubootversion:
2406 @echo $(UBOOTVERSION)
2407
2408 # Single targets
2409 # ---------------------------------------------------------------------------
2410 # Single targets are compatible with:
2411 # - build with mixed source and output
2412 # - build with separate output dir 'make O=...'
2413 # - external modules
2414 #
2415 # target-dir => where to store outputfile
2416 # build-dir => directory in kernel source tree to use
2417
2418 ifeq ($(KBUILD_EXTMOD),)
2419 build-dir = $(patsubst %/,%,$(dir $@))
2420 target-dir = $(dir $@)
2421 else
2422 zap-slash=$(filter-out .,$(patsubst %/,%,$(dir $@)))
2423 build-dir = $(KBUILD_EXTMOD)$(if $(zap-slash),/$(zap-slash))
2424 target-dir = $(if $(KBUILD_EXTMOD),$(dir $<),$(dir $@))
2425 endif
2426
2427 %.s: %.c prepare scripts FORCE
2428 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2429 %.i: %.c prepare scripts FORCE
2430 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2431 %.o: %.c prepare scripts FORCE
2432 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2433 %.lst: %.c prepare scripts FORCE
2434 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2435 %.s: %.S prepare scripts FORCE
2436 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2437 %.o: %.S prepare scripts FORCE
2438 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2439 %.symtypes: %.c prepare scripts FORCE
2440 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2441
2442 # Modules
2443 /: prepare scripts FORCE
2444 $(cmd_crmodverdir)
2445 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2446 $(build)=$(build-dir)
2447 %/: prepare scripts FORCE
2448 $(cmd_crmodverdir)
2449 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2450 $(build)=$(build-dir)
2451 %.ko: prepare scripts FORCE
2452 $(cmd_crmodverdir)
2453 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2454 $(build)=$(build-dir) $(@:.ko=.o)
2455 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.modpost
2456
2457 quiet_cmd_genenv = GENENV $@
2458 cmd_genenv = $(OBJCOPY) --dump-section .rodata.default_environment=$@ env/common.o; \
2459 sed --in-place -e 's/\x00/\x0A/g' $@; sed --in-place -e '/^\s*$$/d' $@; \
2460 sort --field-separator== -k1,1 --stable $@ -o $@
2461
2462 u-boot-initial-env: u-boot.bin
2463 $(call if_changed,genenv)
2464
2465 # Consistency checks
2466 # ---------------------------------------------------------------------------
2467
2468 PHONY += coccicheck
2469
2470 coccicheck:
2471 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/$@
2472
2473 # FIXME Should go into a make.lib or something
2474 # ===========================================================================
2475
2476 quiet_cmd_rmdirs = $(if $(wildcard $(rm-dirs)),CLEAN $(wildcard $(rm-dirs)))
2477 cmd_rmdirs = rm -rf $(rm-dirs)
2478
2479 quiet_cmd_rmfiles = $(if $(wildcard $(rm-files)),CLEAN $(wildcard $(rm-files)))
2480 cmd_rmfiles = rm -f $(rm-files)
2481
2482 # read all saved command lines
2483
2484 cmd_files := $(wildcard .*.cmd)
2485
2486 ifneq ($(cmd_files),)
2487 $(cmd_files): ; # Do not try to update included dependency files
2488 include $(cmd_files)
2489 endif
2490
2491 endif #ifeq ($(config-targets),1)
2492 endif #ifeq ($(mixed-targets),1)
2493 endif # skip-makefile
2494
2495 PHONY += FORCE
2496 FORCE:
2497
2498 # Declare the contents of the PHONY variable as phony. We keep that
2499 # information in a variable so we can use it in if_changed and friends.
2500 .PHONY: $(PHONY)